<?php 
/*******************************   C R   ****************************/
class cr  {
      var $connect  ;
      var $requete  ;
      var $texte_req;
      var $table;      // Nom de la table

      var $id;
      var $modele;
      var $id_escale;
      var $reponses;

      // Variables utilises pour rcuprer les rponses
      var $rep;

      // Constructeur
      public function __construct( $id_escale, $cnx ) {
               $this->table = T_CR;
               $this->connect = $cnx ;
               if ( !empty($id_escale) ) {
                    $result = mysqli_query( $this->connect,"SELECT * FROM ".$this->table." WHERE id_escale = '$id_escale'" );
                    $row=mysqli_fetch_object($result) ;
				   if(isset($row->id)){
						$this->id          = $row->id;
						$this->modele      = $row->modele;
						$this->id_escale   = $row->id_escale ;
						$this->reponses    = $row->reponses ;
				   }
                }
             //   $this->litTous();
      }  // Fin constructeur
       /**********************************************************************************
       *  Affectation des variables de rponses pour s_cr_escales.php
       ***********************************************************************************/
      function affecteReponses() {
               // sparation des categories
               $categ = ($this->reponses!="") ? explode( SEP_CATEG , $this->reponses ) : array();
               // pour chaque categ, sparation des lignes
               for ( $c=1; $c<count($categ); $c++ )  {
            //       echo "Categ : ".$categ[$c]."<br>";
                   // Boucle sur les catgories de dpenses (Port Charges, Vessel expenses, ...)
                   $lig = explode( SEP_LIG, $categ[$c] );
                   for ( $l=1; $l<count($lig); $l++ )  {
            //          echo "Lig : ".$lig[$l]."<br>";
                      // Boucle sur les lignes
                      $rep = explode( SEP_REP , $lig[$l] );
                      for ( $i=1; $i<count($rep); $i++ )  {
                         // Boucle sur les rponses
                         $this->rep[$c-1][$l-1][$i-1] = unEscape($rep[$i]) ;
            //             echo "Rep ($c)($l)($i): ".$this->rep[$c-1][$l-1][$i-1]."<br>";
                      }   // Fin boucle sur les rponses
                   }  // Fin boucle sur les lignes
               }   // Fin boucle sur les catgories de dpenses (Port Charges, Vessel expenses, ...)

      }
      //**************************************  INSERTION
      function inserer($modele,$id_escale,$reponses)   {
               $query ="INSERT INTO ".$this->table." (
                        modele
                        ,id_escale
                        ,reponses)
                        VALUES (
                        '$modele'
                        ,'$id_escale'
                        ,'".escape($reponses)."'
                        )" ;

           //echo "Requete :<br>$query<br>";
                    if ( !$ok = mysqli_query( $this->connect, $query ) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  MODIFCATION
      function modifier($id,$id_escale,$reponses)   {

               $query ="UPDATE ".$this->table." SET
                         id_escale = '$id_escale'
                        ,reponses = '".escape($reponses)."'
                        WHERE id = '$id'" ;

            //echo "Requete :<br>$query<br>"; exit();
                    if ( !$ok = mysqli_query( $this->connect, $query ) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  Suppression
      function supprimer($num){
               $ok = mysqli_query( $this->connect, "DELETE FROM ".$this->table." WHERE id = '$num'" );

               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }

      //************************************** Verif si existe
      function existe($id) {
           $query = "SELECT id FROM ".$this->table." WHERE id='$id'";
           $result = mysqli_query( $this->connect, $query );
           if ( mysqli_num_rows($result) > 0 ) { return true ; }
           else { return false ; }
      }
      //************************************** Comptage nb total d'enreg
      function nbEnreg() {
           $query = "SELECT id FROM ".$this->table;
           $result = mysqli_query( $this->connect, $query );
           $nb = mysqli_num_rows ($result) ;
           mysqli_free_result($result) ;
           return $nb ;
      }
      //************************************** Suppression de tous les enregistrements
      function vider() {
           $query = "DELETE FROM ".$this->table;
           $result = mysqli_query( $this->connect, $query );
      }
      //************************************** Recherche de l'id suivant
      function getNextId(){
               $query = "SELECT id FROM ".$this->table." ORDER BY id DESC LIMIT 0,1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object ($result) ;
               return $row->id + 1 ;
      }
}  // Fin classe

?>