<?php 
/*******************************   P R O F O R M A   ****************************/
class proforma  {
      var $connect  ;		var $id  ;
      var $requete  ;
      var $texte_req;
      var $table;  // nom de la table

      var $id_escale;
      var $id_escale_generated;
      var $date;
      var $appt;
      var $txchange;
      var $darrived;
      var $dsailed;
      var $comments;
	  var $status;


      // tableaux pour lignes
      var $id_lib;    // id du libell dans table T_PROF_LIBELLES 
      var $existe_ligne;  // o si la ligne existe dans table T_PROF_LIGNES  : pour creat/maj/supp dans e_proforma 
      var $type;      // type de ligne : titre ou ligne
      var $libelle;   // libell d'origine ou stock dans ligne si ligne utilise 
      var $niveau;     // niveau du libell. Utilis qd type=titre 
      var $mt_local;
      var $mt_usd;
      var $modif;     // o si libell modifiable
      var $existe;
      var $txstocke;  // taux de change lu dans table T_TAUX_CHANGE pour proposition dans nouvelle proforma  
      var $total_titre;  // du type $total_titre['10'] : pour savoir si un titre a des valeurs ou non. Pour ne pas imprimer les titres vides
	  /*Start for HP*/
      var $row_order; 
	  var $comments_free; 
	  /*End for HP*/
      // Constructeur
      public function __construct( $id_escale, $cnx,$id_escale_generated=null ) {
               $this->table = T_PROFORMAS;
               $this->connect = $cnx ;
               $this->litLignesStandard() ;
               
               if ( !empty($id_escale) ) {
				   
				   $result = mysqli_query( $this->connect,"SELECT * FROM ".$this->table." WHERE id_escale = '$id_escale'  and  id='$id_escale_generated' ");
                    mysqli_num_rows($result) == 0 ? $this->existe=false :  $this->existe=true;
                    $row=mysqli_fetch_object($result) ;  
							$this->id   	   = @$row->id;                              
                            $this->id_escale   = @$id_escale ;
                            $this->date        = @$row->date;
                            $this->appt        = @$row->appt ;
                            $this->txchange    = @$row->txchange ;
                            $this->darrived    = @$row->darrived ;
                            $this->dsailed     = @$row->dsailed ;
                            $this->comments    = @$row->comments ;
							$this->status      = @$row->status ;
                            $this->expected_vessel    = @$row->expected_vessel ;		
							/*Start for Hitesh*/
							$this->contact_type    = @$row->contact_type ;							
							$this->contact_comp_id    = @$row->contact_comp_id ;							
							$this->comments_free    = @$row->comments_free ;							
							/*End for Hitesh*/					
                    $this->litLignesExistantes();
                    $this->litTauxChange("USD"); 
               }
      }  // Fin constructeur
      
      /**********************************************************************************
      *  Lecture des lignes dans la table PROF_LIBELLES
      *  Il s'agit de tous les libells, qu'elles soient utilises ou non
      ***********************************************************************************/
      function litLignesStandard() {
               // Lecture des libelles standards
               $result = mysqli_query( $this->connect,"SELECT * FROM ".T_PROF_LIBELLES." ORDER BY niveau, position");
               while ( $row = mysqli_fetch_object($result)) {
                  // on rcupre les valeurs au cas ou ligne non utilise dans la proforma de cette escale
                  $this->id_lib[]   = $row->id ;
                  $this->type[]     = $row->type ;
                  $this->niveau[]   = $row->niveau ;
                  $this->libelle[]  = $row->libelle ;
                  $this->modif[]    = $row->modif ;
                  $this->mt_local[] = 0;
				  /*Start for HP*/
				  $this->row_order[] = $row->position ;
				  /*End for HP*/
               }
      }
      /**********************************************************************************
      *  Lecture des lignes existantes dans la proforma
      ***********************************************************************************/
      function litLignesExistantes() {				
               // Parcours des libelles standards
			   /*Start for HP*/
			   $ii=1;
			   /*End for HP*/
               for ( $i=0; $i<count($this->id_lib); $i++ ) {				   				   
                  if ($this->type[$i]=='titre') {
					  /*Start for HP*/
					  $ii=1;  
					  /*End for HP*/
                     $titre_en_cours = $this->niveau[$i];  
                  }				  
                  	switch (T_PROF_LIGNES) {						
						case "prof_lignes_oss" : $last_eid = 7; break;						
						case "prof_lignes_oss_guad" : $last_eid = 2; break;
						case "prof_lignes_guad" : $last_eid = 370; break;
						case "prof_lignes_ant" : $last_eid = 86; break;	
						case "prof_lignes_asgp" : $last_eid = 5; break;
						default: $last_eid = 1776; break;					
					}
					/*					if(T_PROF_LIGNES=='prof_lignes_oss')					{						$last_eid = 7;					}					else if(T_PROF_LIGNES=='prof_lignes_oss_guad')					{						$last_eid = 2;					}					else if(T_PROF_LIGNES=='prof_lignes_guad')					{						$last_eid = 370;					}					else if(T_PROF_LIGNES=='prof_lignes_ant')					{						$last_eid = 86;					}					else(T_PROF_LIGNES=='prof_lignes_oss')					{						$last_eid = 1776;					}					*/										if($this->id > $last_eid){					$id = $this->id;					}else{					$id = 0;					}				 
					                 $query = "SELECT * FROM ".T_PROF_LIGNES." WHERE id_escale = '".$this->id_escale."' AND id_libelle = '".$this->id_lib[$i]."' and  id_escale_generated='".$id."'" ;
                  $result = mysqli_query( $this->connect,$query);
				  
                  while ($ligne = mysqli_fetch_object($result)) {
                    // ligne correspondant  ce libell trouve ( si plusieurs -impossible normalement-, sera la dernire)
                    $this->libelle[$i]    = $ligne->libelle ;
                    $this->existe_ligne[$i]   = "o" ;
                    $this->mt_local[$i]   = $ligne->mt_local;
					/*Start for HP*/
					if($ligne->row_order==0){
						$this->row_order[$i] = $ii;
					}else{
						$this->row_order[$i] = $ligne->row_order;						
					}
					$ii++;
					/*End for HP*/
                    // calcul usd
                    $this->mt_usd[$i] = $this->mt_local[$i] * $this->txchange;					
                  }
                  //echo "cl_prof - titre_en_cours :".$titre_en_cours."<br>";
                  //echo "cl_prof - mt_local($i) :".$this->mt_local[$i]."<br>";
                  if(isset($this->total_titre[$titre_en_cours])){
				   	$this->total_titre[$titre_en_cours] += $this->mt_local[$i];
				  }else{
					  $this->total_titre[$titre_en_cours] = $this->mt_local[$i];
				  }
                  //echo "cl_prof - total_titre($titre_en_cours) :".$this->total_titre[$titre_en_cours]."<br>";
               }
      }
	  
	  /*Start for HP*/
	  function litLignesExistantes_NEW($id_escale, $cnx,$id_escale_generated=null) {		  		
		// Parcours des libelles standards
		switch (T_PROF_LIGNES) {
			case "prof_lignes_oss" :
				$last_eid = 7;
				break;
			case "prof_lignes_oss_guad" :
				$last_eid = 2;
				break;
			case "prof_lignes_guad" :
				$last_eid = 370;
				break;
			case "prof_lignes_ant" :
				$last_eid = 86;
				break;
			case "prof_lignes_asgp" :						
				$last_eid = 5;						
				break;		
			default:
				$last_eid = 1776;
				break;
		}					
		if($id_escale_generated > $last_eid){
			$id = $id_escale_generated;
		}else{
			$id = 0;
		}				 
		
		$query = "SELECT p.*,pl.id,pl.type,pl.niveau,pl.position,pl.modif,pl.libelle as pl_libelle FROM ".T_PROF_LIGNES." p 
					LEFT JOIN ".T_PROF_LIBELLES." pl ON pl.id = p.id_libelle
					WHERE p.id_escale = '".$id_escale."' AND p.id_escale_generated='".$id."' ORDER BY pl.niveau,p.row_order " ;
		$result = mysqli_query( $this->connect,$query);
		$data_new = array();
		while ($ligne = mysqli_fetch_object($result)) {
			$query1 = "SELECT * FROM ".T_PROF_LIBELLES." WHERE niveau = '".$ligne->niveau."' AND type='titre'";
			$result1 = mysqli_query( $this->connect,$query1);

			while ($ligne1 = mysqli_fetch_object($result1)) {
				$data_new[$ligne1->libelle]['id_lib'][]   = $ligne->id ;
				$data_new[$ligne1->libelle]['type'][]     = $ligne->type ;
				$data_new[$ligne1->libelle]['niveau'][]   = $ligne->niveau ;
				$data_new[$ligne1->libelle]['modif'][]    = $ligne->modif ;
				
				$data_new[$ligne1->libelle]['libelle'][] = $ligne->libelle ;
				$data_new[$ligne1->libelle]['existe_ligne'][] = "o" ;
				$data_new[$ligne1->libelle]['mt_local'][] = $ligne->mt_local;
				
				$data_new[$ligne1->libelle]['row_order'][] = $ligne->row_order;
			}
		// calcul usd
		}
				  				 
		return $data_new;
       }
	  /*End for HP*/
	  
      /**********************************************************************************
      *  Lecture des lignes d'un titre (libell particulier) donn 
      *  et renvoie le nombre de lignes utilises
      
      // A FINIR 31/05/07
       
      ***********************************************************************************/
      function litLignesTitre($id_titre) {
                  $query = "SELECT * FROM ".T_PROF_LIGNES." WHERE id_escale = '".$this->id_escale."' AND id_libelle = '".$id_libelle."'" ;
                  $result = mysqli_query( $this->connect,$query);
                  return mysqli_num_rows($result);
      }
	  
	  // LEO START 
	  function getContactTypeName($contact_type,$contact_comp_id){
		  $query = "SELECT compagnie FROM ".T_TIERS." WHERE type = '".$contact_type."' AND id = '".$contact_comp_id."'" ;
		  $result = mysqli_query( $this->connect,$query);
		  $mysqli_num_rows=mysqli_num_rows($result);
		  $contactName="";
		  if($mysqli_num_rows>0){
		  	while($row=mysqli_fetch_assoc($result)){
				$contactName=$row['compagnie'];
			}
		  }
		  return $contactName;
	  }
	  // LEO END

      /**********************************************************************************
      *  INSERTION PROFORMA
      ***********************************************************************************/
	  //Start for HP  (added below function '$comments_free' value)
      function inserer($id_escale,$date,$appt,$txchange,$darrived,$dsailed,$comments,$status='a',$expected_vessel=0,$contact_type='',$contact_comp_id=0,$comments_free='')   {
          $dsailed = ($dsailed=="") ? NULL : $dsailed;     
		  $query ="INSERT INTO ".$this->table." SET 
                        id_escale= '$id_escale'
                        ,date='$date'
                        ,appt='".escape($appt)."'
                        ,txchange='".floatval(@$txchange)."'
                        ,darrived=".($darrived==NULL ? "NULL" : "'$darrived'")."
                        ,dsailed=".($dsailed==NULL ? "NULL" : "'$dsailed'")."
                        ,comments='".escape($comments)."'
						,status='$status'						
						,expected_vessel='".(($expected_vessel=='') ? 0 : $expected_vessel)."'
						,contact_type='$contact_type'
						,contact_comp_id='".(($contact_comp_id=='') ? 0 : $contact_comp_id)."'
						,comments_free='".escape($comments_free)."'
                        " ;

            //echo "Requete :<br>$query<br>";

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      /**********************************************************************************
      *  MODIFICATION PROFORMA
      ***********************************************************************************/
	   //Start for HP  (added below function '$comments_free' value)
      function modifier($id_escale,$date,$appt,$txchange,$darrived,$dsailed,$comments,$contact_type,$contact_comp_id,$comments_free)   {
               $query ="UPDATE ".$this->table." SET
                         date='$date'
                        ,appt='".escape($appt)."'
                        ,txchange='".escape($txchange)."'
                        ,darrived='$darrived'
                        ,dsailed='$dsailed'
                        ,comments='".escape($comments)."'
						,contact_type='$contact_type'
                        ,contact_comp_id='$contact_comp_id' 
						,comments_free='".escape($comments_free)."'
                        WHERE id_escale = '$id_escale'" ;

            //echo "Requete :<br>$query<br>"; exit();

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
	  //Start for HP  (added below function '$comments_free' value)
      function modifier_new($id_escale,$date,$appt,$txchange,$darrived,$dsailed,$comments,$expected_vessel,$id_escale_generated,$contact_type,$contact_comp_id,$comments_free)   {
		 				$id_escale_generated =$id_escale_generated;
          $date_field = (empty($date) || $date=="") ? '' : "date='".$date."',"; 
		  $darrived_field = (empty($darrived) || $darrived=="") ? '' : ",darrived='".$darrived."'"; 
		  $dsailed_field = (empty($dsailed) || $dsailed=="") ? '' : ",dsailed='".$dsailed."'"; 
		  $query ="UPDATE ".$this->table." SET
                        $date_field
                        appt='".escape($appt)."'
                        ,txchange='".floatval($txchange)."'
                        $darrived_field
                        $dsailed_field
                        ,comments='".escape($comments)."'
						,expected_vessel='".intval($expected_vessel)."'
						,contact_type='$contact_type'
                        ,contact_comp_id='".intval($contact_comp_id)."' 
						,comments_free='".escape($comments_free)."'
                        WHERE id_escale = '$id_escale' and id='$id_escale_generated' " ;

            //echo "Requete :<br>$query<br>"; exit();

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }      

      /**********************************************************************************
      *  INSERTION LIGNE PROFORMA
      ***********************************************************************************/
	   // Add for HP "$row_order"
      function insererLigne($id_libelle,$libelle,$mt_local,$row_order)   {
               $query ="INSERT INTO ".T_PROF_LIGNES." SET 
                         id_escale= '$this->id_escale'
                        ,id_libelle= '$id_libelle'
                        ,libelle='$libelle'
						,row_order='$row_order'
                        ,mt_local='".escape($mt_local)."'
                        " ;

          //  echo " - INSERTION :<br>$query<br>";  //exit();

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
	  // Add for HP "$row_order"
	  function insererLigne_new($id_libelle,$libelle,$mt_local,$row_order,$id)   {
								switch (T_PROF_LIGNES) {						
								case "prof_lignes_oss" :						$last_eid = 7;						break;						case "prof_lignes_oss_guad" :						$last_eid = 2;						break;						case "prof_lignes_guad" :						$last_eid = 370;						break;						case "prof_lignes_ant" :						$last_eid = 86;					break;
							case "prof_lignes_asgp" :						$last_eid = 5;						break;	
														default:						$last_eid = 1776;						break;					}									  if($id > $last_eid){					  $id =$id;					  				  }else{					  $id =0;				  }
               $query ="INSERT INTO ".T_PROF_LIGNES." SET 
                         id_escale= '$this->id_escale'
                        ,id_libelle= '$id_libelle'
                        ,libelle='$libelle'
                        ,mt_local='".escape($mt_local)."'
						,row_order='".intval($row_order)."'
						,id_escale_generated='$id'
                        " ;
						
						
          //  echo " - INSERTION :<br>$query<br>";  //exit();

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      /**********************************************************************************
      *  MODIFICATION LIGNE PROFORMA

      ***********************************************************************************/
	   // Add for HP "$row_order"
      function modifierLigne($id_libelle,$libelle,$mt_local,$row_order)   {
               $query ="UPDATE ".T_PROF_LIGNES." SET
                         libelle='$libelle'
                        ,mt_local='".escape($mt_local)."'
						,row_order='$row_order'
                        WHERE id_escale = '".$this->id_escale."' AND  id_libelle = '$id_libelle'" ;

          //  echo " - MODIFICATION :<br>$query<br>"; //exit();

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }
           
                    return $ok  ;
      }
	  // Add for HP "$row_order"
      function modifierLigne_new($id_libelle,$libelle,$mt_local,$row_order,$id_escale_generated)   {
               $query ="UPDATE ".T_PROF_LIGNES." SET
                         libelle='$libelle'
                        ,mt_local='".escape($mt_local)."'
						,row_order='".intval($row_order)."'
                        WHERE id_escale = '".$this->id_escale."' AND  id_libelle = '$id_libelle'  AND  id_escale_generated = '$id_escale_generated' " ;

          //  echo " - MODIFICATION :<br>$query<br>"; //exit();

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }
           
                    return $ok  ;
      }
      /**********************************************************************************
      *  SUPPRESSION LIGNE PROFORMA
      ***********************************************************************************/
      function supprimerLigne($id_lib){
               $query = "DELETE FROM ".T_PROF_LIGNES." WHERE id_escale = '".$this->id_escale."' AND id_libelle='$id_lib'" ;
               $ok = mysqli_query( $this->connect, $query);

         // echo " - SUPPRESSION  :<br>$query<br>"; //exit();
               
               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }
      /**********************************************************************************
      *  Lecture du taux de change dans table T_TAUX_CHANGE
      *  Il s'agit de tous les libells, qu'elles soient utilises ou non
      ***********************************************************************************/
      function litTauxChange($devise) {
               $result = mysqli_query( $this->connect,"SELECT taux FROM ".T_TAUX_CHANGE." WHERE devise='$devise'");
               $row = mysqli_fetch_object($result);
               $this->txstocke   = $row->taux ;
               return;
      }
      /**********************************************************************************
      *  MAJ du taux de change dans table TAUX_CHANGE
      ***********************************************************************************/
      function majTauxChange($devise, $txchange)   {
               $query ="UPDATE ".T_TAUX_CHANGE." SET
                        taux='".escape(floatval($txchange))."'
                        WHERE devise = '$devise'" ;

          //  echo "Requete :<br>$query<br>"; //exit();

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  Suppression
      function supprimer($num){
		  //echo "DELETE FROM ".$this->table." WHERE id LIKE '$num'";die();
               $ok = mysqli_query( $this->connect, "DELETE FROM ".$this->table." WHERE id LIKE '$num'");

               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }

      //************************************** Verif si existe
      function existe($id) {
           $query = "SELECT id FROM ".$this->table." WHERE id_escale='$id_escale '";
           $result = mysqli_query( $this->connect, $query);
           if ( mysqli_num_rows($result) > 0 ) { return true ; }
           else { return false ; }
      }
      //************************************** Comptage nb total d'enreg
      function nbEnreg() {
           $query = "SELECT id FROM ".$this->table."";
           $result = mysqli_query( $this->connect, $query);
           $nb = mysqli_num_rows ($result) ;
           mysqli_free_result($result) ;
           return $nb ;
      }
      //************************************** Suppression de tous les enregistrements
      function vider() {
           $query = "DELETE FROM ".$this->table."";
           $result = mysqli_query( $this->connect, $query);
      }
      //************************************** Recherche de l'id suivant
      function getNextId(){
               $query = "SELECT id FROM ".$this->table." ORDER BY id DESC LIMIT 0,1" ;
               $result = mysqli_query( $this->connect, $query);
               $row = mysqli_fetch_object ($result) ;
               return $row->id + 1 ;
      }
	  
// LEO START - Add new button in top menu
	  
	  /**********************************************************************************
       *  Preparation de la requete pour liste
       ***********************************************************************************/
      function prepReqListe() {
               $this->requete    = "SELECT *
                                    FROM ".$this->table." WHERE status='f'";
               $this-> texte_req = "Liste des proformas" ;
               $this->requete.= " ORDER BY id" ;
          // echo $this->requete ."<br>";
      }
	  function prepReqListe_new($id_escale) {
               $this->requete    = "SELECT *
                                    FROM ".$this->table." WHERE status='a'  and   id_escale=$id_escale";
               $this-> texte_req = "Liste des proformas" ;
               $this->requete.= " ORDER BY id" ;
           //echo $this->requete ."<br>";
      }
	  
	  //**************************************  AFFICHAGE
      function affiche_new($page, $total, $nbpp, $p0="c"){
               $colspan = 6;
               //  Titre
               echo '<table id="titreliste" width="75%" border="0" cellspacing="0" cellpadding="0">';
               echo '  <tr>';
               echo '    <td width="25%" align="left"><a href="./s_proforma_f.php?=SID&p0=c"></a></td>';
               echo '    <th width="50%" align="center">Liste des future proformas</th>';
               echo '    <td width="25%" align="right">&nbsp;</td>';
               echo '  </tr>';
               echo '</table>';

               //  En-tete
               echo '<table id="liste" width="60%" border="0" cellspacing="0" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <th align="left" width="15%" valign="top"><b>ID</b></th>';
			   echo '    <th align="left" width="20%" valign="top"><b>Date</b></th>';
			   echo '    <th align="left" width="20%" valign="top"><b>Arrived Date</b></th>';
			   echo '    <th align="left" width="15%" valign="top"><b>Sailed Date</b></th>';
			   echo '    <th align="left" width="15%" valign="top"><b>Exch. rate</b></th>';
               echo '  </tr>';
               echo '<tbody>';
               // affichage lignes
               $debut = ($page - 1 ) * $nbpp ;
			   //echo $this->requete." LIMIT $debut,$nbpp";
               $result = mysqli_query( $this->connect,$this->requete." LIMIT $debut,$nbpp");
			   //echo $result_count = mysqli_num_rows($result);
		  		$bgcolor="";
               while ( $row = mysqli_fetch_object($result)) {
                       $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
                       //
					   $url ="javascript:popup('./s_proforma.php?=SID&id_escale=".$row->id_escale."&id_escale_generated=".$row->id."','_blank','850','700','100','100','yes','yes')";
                       echo '  <tr align="left" bgcolor="'.$bgcolor.'">';
                       echo '    <td valign="top"><a href="'.$url.'">'.$row->id.'</a></td>';
					   echo '    <td valign="top">'.date("d/m/Y",strtotime($row->date)).'</td>';
					   echo '    <td valign="top">'.(($row->darrived!="") ? date("d/m/Y",strtotime($row->darrived)) : '').'</td>';
					   echo '    <td valign="top">'.(($row->dsailed!="") ? date("d/m/Y",strtotime($row->dsailed)) : '').'</td>';
					   echo '    <td valign="top">'.$row->txchange.'</td>';
                       echo '  </tr>';
               }
               echo '</tbody>';
               mysqli_free_result($result);
               $nbpages = @ceil($total/$nbpp) ;
               echo '<tfoot>';
               if ( $total > 0 ) {
                  echo '  <tr valign="bottom">';
                  echo '    <td colspan="'.$colspan.'">';
                  echo '              '.$total.' proforma(s) - Page '.$page.'/'.$nbpages.' &nbsp;&nbsp;&nbsp;>>>>&nbsp;&nbsp;&nbsp;';
                  for ( $i = 1 ; $i <= $nbpages ; $i++ ) {
                     echo '     <a href="l_proforma.php?=SID&page='.$i.'&p0='.$p0.'">'.$i.'</a>&nbsp; ';
                  }
                  echo '    </td>';
                  echo '  </tr>';
                }
                else {
                   echo '  <tr height="200">';
                   echo '     <td align="center" colspan="'.$colspan.'">';
                   echo '        Aucune proforma.</td>';
                   echo '  </tr>';
                }
                  echo '      </td>';
                  echo '   </tr>';
                  echo '</table>';
                  echo '</tfoot>';
      }

      function affiche($page, $total, $nbpp, $p0="c"){
               $colspan = 6;
               //  Titre
               echo '<table id="titreliste" width="75%" border="0" cellspacing="0" cellpadding="0">';
               echo '  <tr>';
               echo '    <td width="25%" align="left"><a href="./s_proforma_f.php?=SID&p0=c">Nouvelle proforma</a></td>';
               echo '    <th width="50%" align="center">Liste des future proformas</th>';
               echo '    <td width="25%" align="right">&nbsp;</td>';
               echo '  </tr>';
               echo '</table>';

               //  En-tete
               echo '<table id="liste" width="60%" border="0" cellspacing="0" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <th align="left" width="15%" valign="top"><b>ID</b></th>';
			   echo '    <th align="left" width="20%" valign="top"><b>Date</b></th>';
			   echo '    <th align="left" width="20%" valign="top"><b>Arrived Date</b></th>';
			   echo '    <th align="left" width="15%" valign="top"><b>Sailed Date</b></th>';
			   echo '    <th align="left" width="15%" valign="top"><b>Exch. rate</b></th>';
               echo'     <th align="center" width="15%" valign="top"><img src="./images/ico_supp.gif" widtd="20" height="16"></th>';
               echo '  </tr>';
               echo '<tbody>';
               // affichage lignes
               $debut = ($page - 1 ) * $nbpp ;
			   //echo $this->requete." LIMIT $debut,$nbpp";
               $result = mysqli_query( $this->connect, $this->requete." LIMIT $debut,$nbpp");
		  		$bgcolor = "DFEAFB";
               while ( $row = mysqli_fetch_object($result)) {
				   
                       $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
                       //
                       echo '  <tr align="left" bgcolor="'.$bgcolor.'">';
                       echo '    <td valign="top"><a href="./s_proforma_f.php?=SID&id_escale='.$row->id_escale.'&id_escale_generated='.$row->id.'&page='.$page.'&p0=m" title="Modifier">'.$row->id.'</a></td>';
					   echo '    <td valign="top">'.date("d/m/Y",strtotime($row->date)).'</td>';
					   echo '    <td valign="top">'.date("d/m/Y",strtotime($row->darrived)).'</td>';
					   echo '    <td valign="top">'.date("d/m/Y",strtotime($row->dsailed)).'</td>';
					   echo '    <td valign="top">'.$row->txchange.'</td>';
                       echo '    <td valign="top" align="center"><a href="./supp_enreg.php?=SID&p0=proforma&id='.$row->id.'&page='.$page.'" onClick="return confirmation(\'Etes vous sr de vouloir supprimer la proforma '.@$row->nom.' ?\')"><img src="./images/ico_supp.gif" width="20" height="16" border="0" alt="Supprimer cette proforma"></a></td>';
                       echo '  </tr>';
               }
               echo '</tbody>';
               mysqli_free_result($result);
               $nbpages = @ceil($total/$nbpp) ;
               echo '<tfoot>';
               if ( $total > 0 ) {
                  echo '  <tr valign="bottom">';
                  echo '    <td colspan="'.$colspan.'">';
                  echo '              '.$total.' proforma(s) - Page '.$page.'/'.$nbpages.' &nbsp;&nbsp;&nbsp;>>>>&nbsp;&nbsp;&nbsp;';
                  for ( $i = 1 ; $i <= $nbpages ; $i++ ) {
                     echo '     <a href="l_proforma.php?=SID&page='.$i.'&p0='.$p0.'">'.$i.'</a>&nbsp; ';
                  }
                  echo '    </td>';
                  echo '  </tr>';
                }
                else {
                   echo '  <tr height="200">';
                   echo '     <td align="center" colspan="'.$colspan.'">';
                   echo '        Aucune proforma.</td>';
                   echo '  </tr>';
                }
                  echo '      </td>';
                  echo '   </tr>';
                  echo '</table>';
                  echo '</tfoot>';
      }
	  function getAutoId(){
               $query = "SELECT id FROM ".$this->table." ORDER BY id DESC LIMIT 0,1" ;
               $result = mysqli_query( $this->connect, $query);
               $row = mysqli_fetch_object ($result) ;
               $rand_no = rand(1000000, 9999999);
			   $autoid = $row->id + $rand_no ;
			   $query = "SELECT id FROM ".$this->table." WHERE id_escale=$autoid ORDER BY id DESC LIMIT 0,1" ;
               $result = mysqli_query( $this->connect, $query);
               $row_cnt = mysqli_num_rows($result) ;
			   if($row_cnt > 0){
				   $this->getAutoId();
			   }
			   return $autoid;
			   
      }
	  
	  
	  
	  //************************************** Transformation d'une escale future en arrive
      function transFutProforma($id, $num){

              $query = "UPDATE ".$this->table." SET id_escale='$num', status='a' WHERE id_escale='$id' ";
              if ( !$ok = mysqli_query( $this->connect, $query) )  {
                  echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
              }
			  
			  $query2 = "UPDATE ".T_PROF_LIGNES." SET id_escale='$num' WHERE id_escale='$id' ";
              if ( !$ok2 = mysqli_query( $this->connect, $query2 ) )  {
                  echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
              }
			  
              return $ok;
      }
	  function supprimerAllLigneOfEscale($id_lib){
               $query = "DELETE FROM ".T_PROF_LIGNES." WHERE id_escale = '".$id_lib."'" ;
               $ok = mysqli_query( $this->connect, $query);

         // echo " - SUPPRESSION  :<br>$query<br>"; //exit();
               
               if ( $ok ) { 
                 return true ;
               }
               else {
                 return false ;
               }
      }
      function supprimerProforma($id){
               $ok = mysqli_query( $this->connect, "DELETE FROM ".$this->table." WHERE id = '$id'");
			   $ok = mysqli_query( $this->connect, "DELETE FROM ".T_PROF_LIGNES." WHERE id_escale_generated = '$id'");
               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }		function getSelectedVesselId($id_escale_generated){			$query = "SELECT expected_vessel FROM ".$this->table." WHERE id=$id_escale_generated " ;			$result = mysqli_query( $this->connect, $query );			$row_cnt = mysqli_num_rows($result) ;			$expected_vessel = '';			if($row_cnt > 0){				$row = mysqli_fetch_object ($result) ;				$expected_vessel = $row->expected_vessel;			}			return $expected_vessel;	  }
	  
// LEO END - Add new button in top menu

}  // Fin classe

?>