<?php 
/*******************************   T I E R S   ****************************/
class tiers  {
      var $connect  ;
      var $requete  ;
      var $texte_req;
      var $table;      // Nom de la table

      var $id;
      var $type;
      var $compagnie;
      var $adresse;
      var $cp;
      var $ville;
      var $pays;
      var $tel;
      var $fax;
      var $telex;
      var $email;
      var $internet;

      var $texte;
      //var $typ;        // utilis simplement dans le cas ou l'id tiers n'est pas connu = insatnciation classe pour liste, cration

      // tableaux utiliss pour listes droulantes
      var $code_arm;
      var $lib_arm;

      var $code_aff;
      var $lib_aff;

      var $code_acc;
      var $lib_acc;

      var $code_aut;
      var $lib_aut;

      // Constructeur
      public function __construct( $id, $cnx, $typ="" ) {
               $this->table = T_TIERS;
               if ( $typ != "" ) {
                  $this->type = $typ;
               }
               $this->connect = $cnx ;
               if ( !empty($id) ) {
                    $result = mysqli_query( $this->connect,"SELECT * FROM ".$this->table." WHERE id = '$id'");
                    $row=mysqli_fetch_object($result) ;
                            $this->id        = $id;
                            $this->type      = $row->type ;
                            $this->compagnie = $row->compagnie;
                            $this->adresse   = $row->adresse ;
                            $this->cp        = $row->cp ;
                            $this->ville     = $row->ville ;
                            $this->pays      = $row->pays ;
                            $this->tel       = $row->tel ;
                            $this->fax       = $row->fax ;
                            $this->telex     = $row->telex ;
                            $this->email     = $row->email ;
                            $this->internet  = $row->internet ;

                            $this->iniTextes($this->type);
               }
      }  // Fin constructeur
       /**********************************************************************************
       *  Lecture de tous les enregistrements selon type
       ***********************************************************************************/
      function litTous() {
               // Lecture des armateurs
               $result = mysqli_query( $this->connect,"SELECT id,compagnie FROM ".$this->table." WHERE type='arm' ORDER BY compagnie");
               while ( $row = mysqli_fetch_object($result)) {
                  $this->code_arm[] = $row->id ;
                  $this->lib_arm[]  = $row->compagnie ;
               }
               mysqli_free_result($result);
               // Lecture des affreteurs
               $result = mysqli_query( $this->connect,"SELECT id,compagnie FROM ".$this->table." WHERE type='aff' ORDER BY compagnie");
               while ( $row = mysqli_fetch_object($result)) {
                  $this->code_aff[] = $row->id ;
                  $this->lib_aff[]  = $row->compagnie ;
               }
               mysqli_free_result($result);
               // Lecture des accounting
               $result = mysqli_query( $this->connect,"SELECT id,compagnie FROM ".$this->table." WHERE type='acc' ORDER BY compagnie" );
               while ( $row = mysqli_fetch_object($result)) {
                  $this->code_acc[] = $row->id ;
                  $this->lib_acc[]  = $row->compagnie ;
               }
               mysqli_free_result($result);
               // Lecture des autres intevenants
               $result = mysqli_query( $this->connect,"SELECT id,compagnie FROM ".$this->table." WHERE type='aut' ORDER BY compagnie");
               while ( $row = mysqli_fetch_object($result)) {
                  $this->code_aut[] = $row->id ;
                  $this->lib_aut[]  = $row->compagnie ;
               }
               mysqli_free_result($result);
      }
       /**********************************************************************************
       *  Preparation de la requete pour liste
       ***********************************************************************************/
      function iniTextes($typ) {
         $this->type       = $typ;
         switch ( $typ ) {
            case "arm" :
               $this->texte[] = "Liste des armateurs";
               $this->texte[] = "Nouvel armateur";
               $this->texte[] = "armateur(s)";
               $this->texte[] = "Nb total";
               $this->texte[] = "Saisie des armateurs";
               $this->texte[] = "Modification armateur";
               $this->texte[] = "armateur";
               $this->texte[] = "";
            break;
            case "aff" :
               $this->texte[] = "Liste des affrteurs";
               $this->texte[] = "Nouvel affrteur";
               $this->texte[] = "affrteur(s)";
               $this->texte[] = "Nb total";
               $this->texte[] = "Saisie des affrteurs";
               $this->texte[] = "Modification affrteur";
               $this->texte[] = "affrteur";
               $this->texte[] = "";
            break;
            case "acc" :
               $this->texte[] = "Liste des accounting";
               $this->texte[] = "Nouvel accounting";
               $this->texte[] = "accounting";
               $this->texte[] = "Nb total";
               $this->texte[] = "Saisie des accounting";
               $this->texte[] = "Modification accounting";
               $this->texte[] = "accounting";
               $this->texte[] = "";
            break;
            case "aut" :
               $this->texte[] = "Liste des autres intervenants";
               $this->texte[] = "Nouvel intervenant";
               $this->texte[] = "autre(s) intervenant(s)";
               $this->texte[] = "Nb total";
               $this->texte[] = "Saisie des autres intervenants";
               $this->texte[] = "Modification autre intervenant";
               $this->texte[] = "autre intervenant";
               $this->texte[] = "";
            break;

            default:
               echo 'Le type de tiers n\'est pas correctement renseign.<br /><br />';
         }

      }
       /**********************************************************************************
       *  Preparation de la requete pour liste
       ***********************************************************************************/
      function prepReqListe( $mot ) {
               $mot = escape($mot);  
               $this->requete    = "SELECT *
                                    FROM ".$this->table."
                                    WHERE type='".$this->type."'";
               if ( $mot != "" )  {
                  $this->requete .=  " AND compagnie LIKE '%$mot%'";
               }
               $this-> texte_req = $this->texte[0] ;
               $this->requete.= " ORDER BY compagnie" ;
          //  echo $this->requete ."<br>";
      }
      //**************************************  AFFICHAGE
      function affiche($page, $total, $nbpp, $p0="c"){
               $colspan = 6;
               //  Titre
               echo '<form id="form" action="./l_tiers.php?=SID">';
               echo ' <input type="hidden" name="typ" value="'.$this->type.'">  ';
               echo '<table id="titreliste" width="100%" border="0" cellspacing="0" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <td width="20%" align="left" ><a href="./s_tiers.php?=SID&p0=c&typ='.$this->type.'">'.$this->texte[1].'</a></td>';
               echo '    <th width="40%" align="center">'.$this->texte[0].'</th>';
               echo '    <td width="40%" align="right"> ';
               echo '       Rechercher <img src="./images/fleche1.gif" widtd="35" height="12" align="absmiddle"><input type="text" name="mot" size="15">';
               echo '       <input type="image" src="./images/ok.gif" value="Chercher" align="absmiddle">  ';
               echo '       '.$this->texte[3].' : '.$this->nbEnreg();
               echo '    </tr>';
               echo '  </tr>';
               echo '</table>';

               //  En-tete
               echo '<table id="liste" width="100%" border="0" cellspacing="1" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <th align="left" width="25%" valign="top">Compagnie</th>';
               echo '    <th align="left" width="23%" valign="top">Adresse<br />Code postal&nbsp;&nbsp;Ville</th>';
               echo '    <th align="left" width="15%" valign="top">Tlphone<br />Fax</th>';
               echo '    <th align="left" width="15%" valign="top">Email</th>';
               echo '    <th align="left" width="15%" valign="top">Internet</th>';
               echo'     <th align="center" width="5%" valign="top">&nbsp;</th>';
               echo '  </tr>';
             //  echo '  <tr valign="bottom"><td colspan="'.$colspan.'"><hr /></td></tr>';
               echo '<tbody>';
               // affichage lignes
               $debut = ($page - 1 ) * $nbpp ;
               $result = mysqli_query( $this->connect, $this->requete." LIMIT $debut,$nbpp");
               while ( $row = mysqli_fetch_object($result)) {
                       $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
                       //
                       echo '  <tr align="left" bgcolor="'.$bgcolor.'">';
                       echo '    <td valign="top"><a href="./s_tiers.php?=SID&id='.$row->id.'&page='.$page.'&p0=m&typ='.$this->type.'" title="Accder au dtail pour consulter ou modifier">'.$row->compagnie.'</a></td>';
                       echo '    <td valign="top">'.set_col($row->adresse,30).'<br />'.$row->cp.'&nbsp;&nbsp;'.$row->ville.'</td>';
                       echo '    <td valign="top">&nbsp;'.$row->tel.'<br />&nbsp;'.$row->fax.'</td>';
                       echo '    <td valign="top">&nbsp;'.$row->email.'</td>';
                       echo '    <td valign="top">&nbsp;'.set_col($row->internet,20).'</td>';
                       echo '    <td valign="top" align="center"><a href="./supp_enreg.php?=SID&p0=tiers&id='.$row->id.'&page='.$page.'&typ='.$this->type.'"><img src="./images/ico_supp.gif" width="20" height="16" border="0" alt="Supprimer"></a></td>';
                       echo '  </tr>';

                      // echo '  <tr valign="bottom"><td colspan="'.$colspan.'"><hr /></td></tr>';
               }
               echo '</tbody>';
               mysqli_free_result($result);
               $nbpages = @ceil($total/$nbpp) ;
               echo '<tfoot>';
               if ( $total > 0 ) {
                  echo '  <tr valign="bottom">';
                  echo '    <td colspan="'.$colspan.'">';
                  echo '              '.$total.' '.$this->texte[2].' - Page '.$page.'/'.$nbpages.' &nbsp;&nbsp;&nbsp;>>>>&nbsp;&nbsp;&nbsp;';
                  for ( $i = 1 ; $i <= $nbpages ; $i++ ) {
                     echo '     <a href="l_tiers.php?=SID&page='.$i.'&p0='.$p0.'&typ='.$this->type.'">'.$i.'</a>&nbsp; ';
                  }
                  echo '    </td>';
                }
                else {
                   echo '  <tr height="200">';
                   echo '     <td align="center" colspan="'.$colspan.'">';
                   echo '        Pas d\'enregistrement.</td>';
                   echo '  </tr>';
                }
                  echo '      </td>';
                  echo '   </tr>';
                  echo '</tfoot>';
                  echo '</table>';
                  echo '</form>';
      }

      //**************************************  INSERTION
      function inserer($type,$compagnie,$adresse,$cp,$ville,
                       $pays,$tel,$fax,$telex,$email,$internet)   {

               $query ="INSERT INTO ".$this->table." (
                        type,
                        compagnie,
                        adresse,
                        cp,
                        ville,
                        pays,
                        tel,
                        fax,
                        telex,
                        email,
                        internet)
                        VALUES (
                        '$type',
                        '".escape($compagnie)."',
                        '".escape($adresse)."',
                        '".escape($cp)."',
                        '".escape($ville)."',
                        '".escape($pays)."',
                        '".escape($tel)."',
                        '".escape($fax)."',
                        '".escape($telex)."',
                        '".escape($email)."',
                        '".escape($internet)."'
                        )" ;

          //  echo "Requete :<br>$query<br>";
                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  MODIFCATION
      function modifier($id,$compagnie,$adresse,$cp,$ville,
                       $pays,$tel,$fax,$telex,$email,$internet)   {

               $query ="UPDATE ".$this->table." SET
                        compagnie = '".escape($compagnie)."',
                        adresse = '".escape($adresse)."',
                        cp = '".escape($cp)."',
                        ville = '".escape($ville)."',
                        pays = '".escape($pays)."',
                        tel = '".escape($tel)."',
                        fax = '".escape($fax)."',
                        telex = '".escape($telex)."',
                        email = '".escape($email)."',
                        internet = '".escape($internet)."'
                        WHERE id = '$id'" ;

            //echo "Requete :<br>$query<br>"; exit();
                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  Suppression
      function supprimer($num){
               $ok = mysqli_query( $this->connect, "DELETE FROM ".$this->table." WHERE id LIKE '$num'");

               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }

      //**************************************  Recherche suivant pour parcours table
      function litSuivant($id){
               global $pr_html ;
               global $cnx ;
               // On rcupre l'enregistrement dont le num correspond au suivant
               $query = "SELECT id FROM ".$this->table." WHERE id>'$id' LIMIT 1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object($result) ;
               // on vrifie si c'est le dernier enregistrement
               if (mysqli_num_rows($result) == 0 ) {
                  $suiv = $id  ;
               }
               else {
                  $suiv = $row->id ;
               }
               return $suiv ;
      }
      //**************************************  Recherche precedent pour parcours table
      function litPrecedent($id){
               global $pr_html ;
               global $cnx ;
               // On rcupre l'enregistrement dont le num correspond au precedent
               $query = "SELECT id FROM ".$this->table." WHERE id<'$id' ORDER BY id DESC LIMIT 1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object($result) ;
               // on vrifie si c'est le premier enregistrement
               if (mysqli_num_rows($result) == 0 ) {
                  $prec = $id  ;
               }
               else {
                  $prec = $row->ref ;
               }
               return $prec ;
      }
      //************************************** Verif si existe
      function existe($id) {
           $query = "SELECT id FROM ".$this->table." WHERE id='$id'";
           $result = mysqli_query( $this->connect, $query);
           if ( mysqli_num_rows($result) > 0 ) { return true ; }
           else { return false ; }
      }
      //************************************** Comptage nb total d'enreg
      function nbEnreg() {
           $query = "SELECT id FROM ".$this->table." WHERE type='".$this->type."'";
           $result = mysqli_query( $this->connect, $query);
           $nb = mysqli_num_rows ($result) ;
           mysqli_free_result($result) ;
           return $nb ;
      }
      //************************************** Suppression de tous les enregistrements
      function vider() {
           $query = "DELETE FROM ".$this->table;
           $result = mysqli_query( $this->connect, $query);
      }
      //************************************** Recherche de l'id suivant
      function getNextId(){
               $query = "SELECT id FROM ".$this->table." ORDER BY id DESC LIMIT 0,1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object ($result) ;
               return $row->id + 1 ;
      }
}  // Fin classe

?>