<?php 
setlocale(LC_ALL, "fr"); /// a voir

/*************************************
*  Includes code
*************************************/
include ( DIR_COMMON . "outils.inc.php" ) ;
include ( DIR_COMMON . "common.inc.php" ) ;

/*************************************
*  Includes classes
*************************************/
include ( DIR_COMMON . "pr_dbase.inc" ) ;
include ( DIR_COMMON . "pr_html.inc" ) ;

/*************************************
*  Instanciation classes courantes
*************************************/
$pr_html = new pr_html ;
$cnx  = new connexion() ;
/*************************************
*  Initialisation variables
*************************************/
// dcalage horaire utilis dans : cl_escale pour calcul date de modif d'apres valeur enregistre en gmtime 
   //define ("DECALHORAIRE" , date("Z") ) ;    // gmt - dcalage du serveur
   define ("DECALHORAIRE" , -14400 ) ;   //  gmt - 4 heures 
   // Date du jour en timestamp pour tests de slection Enregistrements
   $datejour = gmmktime(date("h"),date("i"),date("s"),date("m"),date("d"),date("y")) + DECALHORAIRE ;
   define ("DATEJOUR" , $datejour ) ;
   
   // date du jour en franais
  $jsem = date('w'); // jour de la semaine
  $jmois = date('j'); // jour du mois ('d' est aussi utilisable)
  $mois = date('n'); // mois de l'annee
  $annee = date('Y'); // l'annee
  $tabjour=array('Dimanche', 'Lundi', 'Mardi', 'Mercredi', 'Jeudi', 'Vendredi','Samedi');
  $tabmois=array('0', 'janvier', 'fvrier', 'mars', 'avril', 'mai', 'juin',
                 'juillet', 'aot', 'septembre', 'octobre', 'novembre','dcembre');
  // construction de la date formatee
  $heure = date ("H:i:s", gmmktime(date("h"),date("i"),date("s"),date("m"),date("d"),date("y")));
  $datefr = $tabjour[$jsem]." $jmois ".$tabmois[$mois]." $annee";      // ." ".$heure

// Listes de mois et d'annes au dpart de la date du jour
  $month = date("m" , DATEJOUR);
  $year  = date("Y" , DATEJOUR);
  $m     = array("Janvier","Fvrier","Mars","Avril","Mai" ,"Juin" ,"Juillet" ,"Aot" ,"Septembre" ,"Octobre" ,"Novembre" ,"Dcembre");
  for (  $i=0; $i<10 ; $i++ ) {
     $years[$i] = $year + $i;
  }
  for (  $i=0; $i<12 ; $i++ ) {
     ($month + $i) <= 12 ? $months[$i] = $m[$month + $i -1] : $months[$i] = $m[$month + $i -12] ;
     // echo $months[$i]."<br>";
  }

// NOM DES TABLES SUIVANT MARTINIQUE ou GUADELOUPE
switch ($usr_site) {

   case "Guadeloupe" :
     define ("T_BATEAUX" , "bateaux" ) ;
     define ("T_CATBAT" , "catbat" ) ;
     define ("T_CONTACTS" , "contacts" ) ;
     define ("T_DESTINATIONS" , "destinations" ) ;
     define ("T_ESCALES" , "escales_guad" ) ;
     define ("T_CR" , "cr_guad" ) ;
     define ("T_PROVENANCES" , "provenances" ) ;
     define ("T_QUAIS" , "quais_guad" ) ;
     define ("T_TIERS" , "tiers" ) ;
     define ("T_TYPBAT" , "typbat" ) ;
     define ("T_COMPTEURS" , "compteurs_guad" ) ;
     define ("T_HISTO" , "histo_guad" ) ;
     define ("T_PROF_LIBELLES" , "prof_libelles" ) ;
     define ("T_PROFORMAS" , "proformas_guad" ) ;
     define ("T_PROF_LIGNES" , "prof_lignes_guad" ) ;
     define ("T_TAUX_CHANGE" , "taux_change" ) ;
   break;

   default:
     // case "Martnique" :
     define ("T_BATEAUX" , "bateaux" ) ;
     define ("T_CATBAT" , "catbat" ) ;
     define ("T_CONTACTS" , "contacts" ) ;
     define ("T_DESTINATIONS" , "destinations" ) ;
     define ("T_ESCALES" , "escales_mart" ) ;
     define ("T_CR" , "cr_mart" ) ;
     define ("T_PROVENANCES" , "provenances" ) ;
     define ("T_QUAIS" , "quais_mart" ) ;
     define ("T_TIERS" , "tiers" ) ;
     define ("T_TYPBAT" , "typbat" ) ;
     define ("T_COMPTEURS" , "compteurs_mart" ) ;
     define ("T_HISTO" , "histo_mart" ) ;
     define ("T_PROF_LIBELLES" , "prof_libelles" ) ;
     define ("T_PROFORMAS" , "proformas_mart" ) ;
     define ("T_PROF_LIGNES" , "prof_lignes_mart" ) ;
     define ("T_TAUX_CHANGE" , "taux_change" ) ;
   break;

}

/************************************************************
* AFFECTATION DES SEPARATEURS POUR LES CR D'ESCALES
*    utilis dans cl_cr et e_cr_escale
*************************************************************/
define ("SEP_CATEG" , "##" ) ;
define ("SEP_LIG" , "&&" ) ;
define ("SEP_REP" , "||" ) ;
// n du modele de compte rendu  inclure. Change selon les modifs apportes au cr
define ("MODELE_CR" , "1" ) ; // 20/04/06

/*********************************************************
*  Assignation  variables POST et SESSION par variables globales
**********************************************************/
   $php_version = preg_replace("/[^\d]/", '', phpversion());
   // assignation des variables passs en post et de session
   if ($php_version < 410 ) {
      $post = @$HTTP_POST_VARS ;
      $sess = @$HTTP_SESSION_VARS ;
   }
   else {
      $post = @$_POST ;
      $sess = @$_SESSION ;
   }

   while( list($cle, $val) = each($post) ) {
      $$cle = $val ;
      // echo "$cle : $val<br>";
   }
   while( list($cle, $val) = @each($sess) ) {
     $$cle = $val ;
      // echo "$cle : $val<br>";
   }
?>