<?php 
/*******************************   B A T E A U   ****************************/
class bateau  {
      var $connect  ;
      var $requete  ;
      var $texte_req;
      var $table;  // nom de la table

      var $id;
      var $nom;
      var $lg;
      var $larg;
      var $ton;
      var $tirant;
      var $type;
      var $drap;
      var $tel;
      var $fax;
      var $telex;
      var $email;
      var $contact;
      var $lg_amar;
      var $lg_assis;
      var $categ;
      var $volume;

      // tableaux utiliss pour liste droulante
      var $code;
      var $lib;

      // Constructeur
      public function __construct( $id, $cnx ) {
               $this->table = T_BATEAUX;
               $this->connect = $cnx ;
               if ( !empty($id) ) {
                    $result = mysqli_query( $this->connect,"SELECT * FROM ".$this->table." WHERE id = '$id'");
                    $row=mysqli_fetch_object($result) ;
                            $this->id          = $id;
                            $this->nom         = $row->nom ;
                            $this->lg        = $row->lg;
                            $this->larg        = $row->larg ;
                            $this->ton         = $row->ton ;
                            $this->tirant      = $row->tirant ;
                            $this->type        = $row->type ;
                            $this->drap        = $row->drap ;
                            $this->tel         = $row->tel ;
                            $this->fax         = $row->fax ;
                            $this->telex       = $row->telex ;
                            $this->email       = $row->email ;
                            $this->contact     = $row->contact ;
                            $this->lg_amar     = $row->lg_amar ;
                            $this->lg_assis    = $row->lg_assis ;
                            $this->categ       = $row->categ ;
                            $this->volume      = $row->volume ;
               }
      }  // Fin constructeur
       /**********************************************************************************
       *  Lecture de tous les enregistrements
       ***********************************************************************************/
      function litTous() {
               $result = mysqli_query( $this->connect,"SELECT id,nom,type FROM ".$this->table." ORDER BY nom");
               while ( $row = mysqli_fetch_object($result)) {
                  $this->code[] = $row->id ;
                  $this->lib[]  = $row->nom ;
				  $this->pqtype[$row->id]  = $row->type ; // LEO - Just add the new field in the escale page
               }
      }
       /**********************************************************************************
       *  Preparation de la requete pour liste
       ***********************************************************************************/
      function prepReqListe($mot, $champ="nom" , $tri="ASC") {
               $mot = escape($mot);
               $this->requete    = "SELECT ".$this->table.".id,
                                            ".T_TYPBAT.".nom AS typebateau
                                            FROM ".$this->table ;
               $this->requete   .= "        LEFT JOIN ".T_TYPBAT." ON ".$this->table.".type=".T_TYPBAT.".id ";

               /*
               $this->requete    = "SELECT id,nom,lg,larg,type,drap,
                                           tel,fax,telex,email,contact,categ
                                    FROM ".$this->table;
               */
               if ( $mot != "" )  {
                  $this->requete .=  " WHERE ".$this->table.".nom LIKE '%$mot%'";
               }
               $this-> texte_req = "Liste des bateaux " ;
               $champ == "" ? $champ = "nom" : nul();
               $champ == "type" ? $champ = "typebateau" : $champ = $this->table.".$champ";
               $tri   == "" ? $tri = "ASC" : nul();
               $this->requete.= " ORDER BY $champ $tri" ;
          //  echo $this->requete ."<br>";
      }
      //**************************************  AFFICHAGE
      function affiche($page, $total, $nbpp, $p0="c"){
               $colspan = 9;
               //  Titre
               echo '<form id="form" action="./l_bateaux.php?=SID">  ';
               echo '<table id="titreliste" width="100%" border="0" cellspacing="0" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <td width="20%" align="left"><a href="./s_bateau.php?=SID&p0=c">Nouveau bateau</a></td>';
               echo '    <th width="40%" align="center">Liste des bateaux</th>';
               echo '    <td width="40%" align="right"> ';
               echo '     Rechercher <img src="./images/fleche1.gif" widtd="35" height="12" align="absmiddle"><input type="text" name="mot" size="15">';
               echo '     <input type="image" src="./images/ok.gif" value="Chercher" align="absmiddle">  ';
               echo '    </td>';
               echo '  </tr>';
               echo '</table>';

               //  En-tete
               echo '<table id="liste" width="100%" border="0" cellspacing="1" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <th align="left" width="16%" valign="top">
                            <a href="./l_bateaux.php?=SID&tri=ASC&champ=nom">
                            <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                            <a href="./l_bateaux.php?=SID&tri=DESC&champ=nom">
                            <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                            <br />Nom
                         </th>';
               echo '    <th align="left" width="7%" valign="top">Long.</th>';
               echo '    <th align="left" width="7%" valign="top">Larg.</th>';
               echo '    <th align="left" width="10%" valign="top">
                           <a href="./l_bateaux.php?=SID&tri=ASC&champ=type">
                           <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                           <a href="./l_bateaux.php?=SID&tri=DESC&champ=type">
                           <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                           <br />Type
                         </th>';
               echo '    <th align="left" width="10%" valign="top">
                           <a href="./l_bateaux.php?=SID&tri=ASC&champ=drap">
                           <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                           <a href="./l_bateaux.php?=SID&tri=DESC&champ=drap">
                           <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                           <br />Drapeau
                         </th>';
               echo '    <th align="left" width="15%" valign="top">Tlphone<br />Fax</th>';
               echo '    <th align="left" width="15%" valign="top">Tlex<br />Email</th>';
               echo '    <th align="left" width="15%" valign="top">Contact</th>';
               echo'     <th align="center" width="5%" valign="top"><img src="./images/ico_supp.gif" widtd="20" height="16"></th>';
               echo '  </tr>';
             //  echo '  <tr valign="bottom"><td colspan="'.$colspan.'"><hr /></td></tr>';
               echo '<tbody>';
               // Lecture types
               include ( DIR_COMMON . "cl_typbat.php") ;
               //$typbat = new typbat( 0, $this->connect) ;
               // affichage lignes
               $debut = ($page - 1 ) * $nbpp ;
               $result = mysqli_query( $this->connect, $this->requete." LIMIT $debut,$nbpp");
		  	   $bgcolor = "EBEAE7";
               while ( $row = mysqli_fetch_object($result)) {
                       $bat = new bateau($row->id , $this->connect);
                       $typbat = new typbat($bat->type , $this->connect);
                       $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
                       //
                       echo '  <tr align="left" bgcolor="'.$bgcolor.'">';
                       echo '    <td valign="top"><a href="./s_bateau.php?=SID&id='.$row->id.'&page='.$page.'&p0=m" title="Accder au dtail pour consulter ou modifier">'.$bat->nom.'</a></td>';
                       echo '    <td valign="top" align="right">'.$bat->lg.'</td>';
                       echo '    <td valign="top" align="right">'.$bat->larg.'</td>';
                       //echo '    <td valign="top">'.$typbat->lib[($bat->type)-1].'('.$bat->type.')</td>';
                       echo '    <td valign="top">'.$typbat->nom.'</td>';
                       echo '    <td valign="top">'.$bat->drap.'</td>';
                       echo '    <td valign="top">'.set_col($bat->tel,15).'<br />'.set_col($bat->fax,15).'</td>';
                       echo '    <td valign="top">&nbsp;'.set_col($bat->telex,15).'<br />'.set_col($bat->email,15).'</td>';
                       echo '    <td valign="top">&nbsp;'.set_col($bat->contact,15).'</td>';
                       echo '    <td valign="top" align="center"><a href="./supp_enreg.php?=SID&p0=bateau&id='.$row->id.'&page='.$page.'" onClick="return confirmation(\'Etes vous sr de vouloir supprimer le bateau '.$bat->nom.' ?\')"><img src="./images/ico_supp.gif" width="20" height="16" border="0" alt="Supprimer ce bateau")></a></td>';
                       echo '  </tr>';

                      // echo '  <tr valign="bottom"><td colspan="'.$colspan.'"><hr /></td></tr>';
               }
               echo '</tbody>';
               mysqli_free_result($result);
               $nbpages = @ceil($total/$nbpp) ;
               echo '<tfoot>';
               if ( $total > 0 ) {
                  echo '  <tr valign="bottom">';
                  echo '    <td colspan="'.$colspan.'">';
                  echo '              '.$total.' bateau(x) - Page '.$page.'/'.$nbpages.' &nbsp;&nbsp;&nbsp;>>>>&nbsp;&nbsp;&nbsp;';
                  for ( $i = 1 ; $i <= $nbpages ; $i++ ) {
                     echo '     <a href="l_bateaux.php?=SID&page='.$i.'&p0='.$p0.'">'.$i.'</a>&nbsp; ';
                  }
                  echo '    </td>';
                  echo '  </tr>';
                  /*
                  echo '        <tr>';
                  echo '          <td colspan="'.$colspan.'">';
                  echo '              Nombre total de bateaux : '.$this->nbEnreg();
                  echo '          </td>';
                  echo '        </tr>';
                  */
                }
                else {
                   echo '  <tr height="200">';
                   echo '     <td align="center" colspan="'.$colspan.'">';
                   echo '        Aucun bateau.</td>';
                   echo '  </tr>';
                }
                  echo '      </td>';
                  echo '   </tr>';
                  echo '</tfoot>';
                  echo '</table>';
                  echo '</form>  ';
      }

      //**************************************  INSERTION
      function inserer($id,$nom,$lg,$larg,$ton,$tirant,$type,$drap,$tel,$fax,
                       $telex,$email,$contact,$lg_amar,$lg_assis,$categ,$volume)   {
               $query ="INSERT INTO ".$this->table." (
                        nom,
                        lg,
                        larg,
                        ton,
                        tirant,
                        type,
                        drap,
                        tel,
                        fax,
                        telex,
                        email,
                        contact,
                        lg_amar,
                        lg_assis,
                        categ,
                        volume)
                        VALUES (
                        '".escape($nom)."',
                        '".escape($lg)."',
                        '".escape($larg)."',
                        '".escape($ton)."',
                        '".escape($tirant)."',
                        '$type',
                        '".escape($drap)."',
                        '".escape($tel)."',
                        '".escape($fax)."',
                        '".escape($telex)."',
                        '".escape($email)."',
                        '".escape($contact)."',
                        '".escape($lg_amar)."',
                        '".escape($lg_assis)."',
                        '$categ',
                        '".escape($volume)."')" ;

          //  echo "Requete :<br>$query<br>";

                    if ( !$ok = mysqli_query( $this->connect, $query) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  MODIFCATION
      function modifier($id,$nom,$lg,$larg,$ton,$tirant,$type,$drap,$tel,$fax,
                        $telex,$email,$contact,$lg_amar,$lg_assis,$categ,$volume)   {

               $query ="UPDATE ".$this->table." SET
                        nom = '".escape($nom)."',
                        lg = '".escape($lg)."',
                        larg = '".escape($larg)."',
                        ton = '".escape($ton)."',
                        tirant = '".escape($tirant)."',
                        type = '".intval($type)."',
                        drap = '".escape($drap)."',
                        tel = '".escape($tel)."',
                        fax = '".escape($fax)."',
                        telex = '".escape($telex)."',
                        email = '".escape($email)."',
                        contact = '".escape($contact)."',
                        lg_amar = '".escape($lg_amar)."',
                        lg_assis = '".escape($lg_assis)."',
                        categ = '".intval($categ)."',
                        volume = '".escape($volume)."'
                        WHERE id = '$id'" ;

            //echo "Requete :<br>$query<br>"; exit();

                    if ( !$ok = mysqli_query( $this->connect, $query ) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  Suppression
      function supprimer($num){
               $ok = mysqli_query( $this->connect, "DELETE FROM ".$this->table." WHERE id = '$num'" );

               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }

      //**************************************  Recherche suivant pour parcours table
      function litSuivant($id){
               global $pr_html ;
               global $cnx ;
               // On rcupre l'enregistrement dont le num correspond au suivant
               $query = "SELECT id FROM ".$this->table." WHERE id>'$id' LIMIT 1" ;
               $result = mysqli_query( $this->connect, $query  );
               $row = mysqli_fetch_object($result) ;
               // on vrifie si c'est le dernier enregistrement
               if (mysqli_num_rows($result) == 0 ) {
                  $suiv = $id  ;
               }
               else {
                  $suiv = $row->id ;
               }
               return $suiv ;
      }
      //**************************************  Recherche precedent pour parcours table
      function litPrecedent($id){
               global $pr_html ;
               global $cnx ;
               // On rcupre l'enregistrement dont le num correspond au precedent
               $query = "SELECT id FROM ".$this->table." WHERE id<'$id' ORDER BY id DESC LIMIT 1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object($result) ;
               // on vrifie si c'est le premier enregistrement
               if (mysqli_num_rows($result) == 0 ) {
                  $prec = $id  ;
               }
               else {
                  $prec = $row->ref ;
               }
               return $prec ;
      }
      //************************************** Verif si existe
      function existe($id) {
           $query = "SELECT id FROM ".$this->table." WHERE id='$id'";
           $result = mysqli_query( $this->connect, $query );
           if ( mysqli_num_rows($result) > 0 ) { return true ; }
           else { return false ; }
      }
      //************************************** Comptage nb total d'enreg
      function nbEnreg() {
           $query = "SELECT id FROM ".$this->table."";
           $result = mysqli_query( $this->connect, $query );
           $nb = mysqli_num_rows ($result) ;
           mysqli_free_result($result) ;
           return $nb ;
      }
      //************************************** Suppression de tous les enregistrements
      function vider() {
           $query = "DELETE FROM ".$this->table."";
           $result = mysqli_query( $this->connect, $query );
      }
      //************************************** Recherche de l'id suivant
      function getNextId(){
               $query = "SELECT id FROM ".$this->table." ORDER BY id DESC LIMIT 0,1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object ($result) ;
               return $row->id + 1 ;
      }
}  // Fin classe

?>