<?php 
/*******************************   E S C A L E   ****************************/
class escale  {
      var $connect  ;
      var $requete  ;
      var $texte_req;
      var $table;      // Nom de la table
      var $ANNEE ;     // anne en cours pour les selects

      var $id ;
      var $num ;
      var $prov ;
      var $dest ;
      var $arrivee ;
      var $arr_jour;
      var $arr_ferie;
      var $arr_precis;
      var $depart ;
      var $dep_jour;
      var $dep_ferie;
      var $dep_precis;
      var $duree ;
	   var $harr_agent;
      var $hdep_agent;
      var $id_bateau ;
      var $id_arm ;
      var $id_aff ;
      var $id_acc ;
      var $id_aut ;
      var $remorq ;
      var $quai1 ;
      var $quai2 ;
      var $quai3 ;
      var $shift ;
      var $carg ;
      var $qte ;
      var $assur ;
      var $sout ;
      var $slop ;
      var $avarie ;
      var $via;
      var $ba;
      var $ba_nom;   // PhR ajout du 20/06/07 avec toute la gestion associe
      var $scan;
      var $rep_scan; // PhR ajout du 09/07/07
      var $com ;
      var $status ;
      var $annule ;   // pour les escales futures non ralises

      // Valeurs associes lues dans les autres tables
      // (car une seul table tiers, donc difficile de faire une seule requete par la suite)
      var $bateau_nom;
      var $arm_nom;
      var $aff_nom;
      var $acc_nom;
      var $aut_nom;
      var $quai1_nom;
      var $quai2_nom;
      var $quai3_nom;
      var $cr_escale;   // true/false : pour savoir si l'esacle contient un cr d'escale
      var $proforma;    // true/false : pour savoir si l'esacle contient une proforma

      var $qui_crea;    // nom du createur de l'escale
      var $qui_modif;   // tableau des utilisateurs ayant modifi l'escale

      // Constructeur
      function escale( $id, $cnx ) {
               global $usr_site, $sess_annee_en_cours;
             //  echo "usr_site dans class escale : $usr_site<br>";
               $this->table = T_ESCALES;
               $this->connect = $cnx ;
               if ( !empty($id) ) {   
                    $result = mysqli_query( $this->connect,"SELECT * FROM ".$this->table." WHERE id = '$id'" );
                    $row=mysqli_fetch_object($result) ;

                            $this->id        = $id;
                            $this->num       = $row->num ;
                            $this->prov      = $row->prov;
                            $this->dest      = $row->dest ;
                            $this->arrivee   = $row->arrivee ;
                          //  $this->arr_jour  = $row->arr_jour ;
                            $this->arr_ferie = $row->arr_ferie ;
                            $this->arr_precis= $row->arr_precis ;
                            $this->depart    = $row->depart ;
                          //  $this->dep_jour  = $row->dep_jour ;
                            $this->dep_ferie = $row->dep_ferie ;
                            $this->dep_precis= $row->dep_precis ;
                            $this->duree     = $row->duree ;
                            $this->harr_agent= $row->harr_agent ;
                            $this->hdep_agent= $row->hdep_agent ;
                            $this->id_bateau = $row->id_bateau ;
                            $this->id_arm    = $row->id_arm ;
                            $this->id_aff    = $row->id_aff ;
                            $this->id_acc    = $row->id_acc ;
                            $this->id_aut    = $row->id_aut ;
                            $this->remorq    = $row->remorq ;
                            $this->quai1     = $row->quai1 ;
                            $this->quai2     = $row->quai2 ;
                            $this->quai3     = $row->quai3 ;
                            $this->shift     = $row->shift ;
                            $this->carg      = $row->carg ;
                            $this->qte       = $row->qte ;
                            $this->assur     = $row->assur ;
                            $this->sout      = $row->sout ;
                            $this->slop      = $row->slop ;
                            $this->avarie    = $row->avarie ;
                            $this->com       = $row->com ;
                            $this->via       = $row->via ;
                            $this->ba        = $row->ba ;
                            $this->ba_nom    = $row->ba_nom ;
                            $this->scan      = $row->scan ;
                            $this->rep_scan  = $row->rep_scan ;
                            $this->status    = $row->status ;
                            $this->annule    = $row->annule ;

                    $this->litValeurs();
                    $this->jourEtFerie();
               }

               //$this->ANNEE = "2" . substr($sess_annee_en_cours, 3, 1); // Avant modif PhR 27/12/09
               /* Preparation du format de l'anne en cours avant et aprs 2010
					*   -	avant 2009 : 2a.xxx (ex : 29.015)
					*   -	aprs 2009 : 2aa.xxx (ex : 210.015)
					*/
					$this->ANNEE = $sess_annee_en_cours > 2009 ? "2" . substr($sess_annee_en_cours, 2, 2) : $this->ANNEE = "2" . substr($sess_annee_en_cours, 3, 1) ;	// PhR 27/12/09
               //echo "this->ANNEE : ".$this->ANNEE."<br>";
              // $usr_site == "Guadeloupe" ?  $this->ANNEE = "G".$this->ANNEE : $this->ANNEE =$this->ANNEE ;
			// }  
	 if ($usr_site == "Martinique" ) {
			$this->ANNEE =$this->ANNEE ; 
		} 
		 elseif ($usr_site == "Guadeloupe" ){ 
		 	$this->ANNEE = "G".$this->ANNEE ; 
		} 
		 elseif ($usr_site == "Oss97" ){ 
		 	$this->ANNEE = "O".$this->ANNEE ; 
		} 
		 elseif ($usr_site == "Oss97_guad" ){ 
		 	$this->ANNEE = "OG".$this->ANNEE ; 
		}
		 else {
			$this->ANNEE = "A".$this->ANNEE ;
		} 



}// Fin constructeur
       /**********************************************************************************
       *  Lecture des valeurs associes
       ***********************************************************************************/
      function litValeurs() {
               // Bateau
               $result = mysqli_query( $this->connect,"SELECT nom FROM ".T_BATEAUX." WHERE id='".$this->id_bateau."'" );
               $row = mysqli_fetch_object($result);
               $this->bateau_nom = $row->nom ;
               // Armateur
               $result = mysqli_query( $this->connect,"SELECT compagnie FROM ".T_TIERS." WHERE id='".$this->id_arm."'" );
               $row = mysqli_fetch_object($result);
               $this->arm_nom = $row->compagnie ;
               // Affreteur
               $result = mysqli_query( $this->connect,"SELECT compagnie FROM ".T_TIERS." WHERE id='".$this->id_aff."'" );
               $row = mysqli_fetch_object($result);
               $this->aff_nom = $row->compagnie ;
               // Accounting
               $result = mysqli_query( $this->connect,"SELECT compagnie FROM ".T_TIERS." WHERE id='".$this->id_acc."'" );
               $row = mysqli_fetch_object($result);
               $this->acc_nom = $row->compagnie ;
               // Autre intervenant
               $result = mysqli_query( $this->connect,"SELECT compagnie FROM ".T_TIERS." WHERE id='".$this->id_aut."'" );
               $row = mysqli_fetch_object($result);
               $this->aut_nom = $row->compagnie ;
               // Quais
               $result = mysqli_query( $this->connect,"SELECT nom FROM ".T_QUAIS." WHERE id='".$this->quai1."'" );
               $row = mysqli_fetch_object($result);
               $this->quai1_nom = $row->nom ;
               $result = mysqli_query( $this->connect,"SELECT nom FROM ".T_QUAIS." WHERE id='".$this->quai2."'" );
               $row = mysqli_fetch_object($result);
               $this->quai2_nom = $row->nom ;
               $result = mysqli_query( $this->connect,"SELECT nom FROM ".T_QUAIS." WHERE id='".$this->quai3."'" );
               $row = mysqli_fetch_object($result);
               $this->quai3_nom = $row->nom ;
               // cr escale
               $result = mysqli_query( $this->connect,"SELECT id_escale FROM ".T_CR." WHERE id_escale='".$this->id_escale."'" );
               //$row = mysqli_fetch_object($result);  // a utiliser si on souhaite rcuprer des valeurs de l'enreg
               if ( mysqli_num_rows($result) > 0 ) {
                 $this->cr_escale = true;
               } else {
                 $this->cr_escale = false;
               }
               // Proforma
               $result = mysqli_query( $this->connect,"SELECT id_escale FROM ".T_PROFORMAS." WHERE id_escale='".$this->id_escale."'" );
               //$row = mysqli_fetch_object($result);  // a utiliser si on souhaite rcuprer des valeurs de l'enreg
               if ( mysqli_num_rows($result) > 0 ) {
                 $this->proforma = true;
               } else {
                 $this->proforma = false;
               }
               // Histo
                 // la creation
               $result = mysqli_query( $this->connect,"SELECT * FROM ".T_HISTO." WHERE id_escale = '".$this->id."' AND type='c' ORDER BY date" );
               if  ( mysqli_num_rows($result) > 0 ) {
                  $row = mysqli_fetch_object($result);
                  $this->qui_crea[nom] = $row->nom ;
                  $this->qui_crea[prenom] = $row->prenom ;
                  $dmodif = $row->date;
                  $ts = datetimeToTimestamp($dmodif)+ DECALHORAIRE;
                  $dmodif = date("Y-m-d H:i:s",$ts) ;
                  $this->qui_crea[date]  = format_date($dmodif,"d") ;
                  $this->qui_crea[heure] = format_date($dmodif,"h");

                  // $this->qui_crea[date] = gmstrftime("%d/%m/%y", $row->date + DECALHORAIRE) ;
                  // $this->qui_crea[heure] = gmstrftime("%H:%M", $row->date + DECALHORAIRE) ;
               }
                 // toutes les modifs
               $result = mysqli_query( $this->connect,"SELECT * FROM ".T_HISTO." WHERE id_escale = '".$this->id."' AND type!='c' ORDER BY date DESC" );
               $i=0;
               while ( $row = mysqli_fetch_object($result)) {
                  $this->qui_modif[nom][$i] = $row->nom ;
                  $this->qui_modif[prenom][$i] = $row->prenom ;
                  $dmodif = $row->date;
                  $ts = datetimeToTimestamp($dmodif)+ DECALHORAIRE;
                  $dmodif = date("Y-m-d H:i:s",$ts) ;
                  $this->qui_modif[date][$i]  = format_date($dmodif,"d") ;
                  $this->qui_modif[heure][$i] = format_date($dmodif,"h");

                  //$this->qui_modif[date][$i] = gmstrftime("%d/%m/%y", $row->date + DECALHORAIRE) ;
                  //$this->qui_modif[heure][$i] = gmstrftime("%H:%M", $row->date + DECALHORAIRE);
                  $i++;
               }
      }
       /**********************************************************************************
       *  Affectation du jour de la semaine et des valeurs ferie et precision
       *  selon que la date et est renseigne ou pas
       ***********************************************************************************/
      function jourEtFerie() {
          // preparation champs jour semaine/ferie/precis
             // Arrivee
             // Si la date est renseigne mais pas le jour de la semaine, on le calcule --> permet d'initialiser le jour des escales avant modifs jour semaine
        //     if  ($this->arrivee == "" || ($this->arrivee != "" && $this->arr_jour == "") )  {
             if ( $this->arrivee != "" )  {
                $this->arr_jour = getJourSem($this->arrivee) ;
             }
             if ( $this->arrivee != "" && $this->arr_precis == "" )  {
                $this->arr_ferie = "n" ;
                if ( $this->arr_jour == "Dimanche" || $this->arr_jour == "Samedi" ) {
                   $this->arr_ferie = "o" ;
                   $this->arr_precis = $this->arr_jour ;
                }
             }
             // Dpart
             // Si la date est renseigne mais pas le jour de la semaine, on le calcule --> permet d'initialiser le jour des escales avant modifs jour semaine
             if  ( $this->depart != "" )  {
                $this->dep_jour = getJourSem($this->depart) ;
             }
             if  ( $this->depart != "" && $this->dep_precis == "" )  {
                $this->dep_ferie = "n" ;
                if ( $this->dep_jour == "Dimanche" || $this->dep_jour == "Samedi" ) {
                   $this->dep_ferie = "o" ;
                   $this->dep_precis = $this->dep_jour;
                }
             }
       }
       /**********************************************************************************
       *  Preparation de la requete pour liste
       *  - $t : a = Arrives
       *         f = Futures
       *         fa = Futures Annules
       ***********************************************************************************/
      function prepReqListe( $t="a" , $champ="num" , $tri="", $ordre_fut="ASC" ) {
               if ($champ=="") {
                 if ($t=="a") {
                   $champ="num";
                 }else {
                   $champ="arrivee";
                 }
               }
               // recupration des variables de selection saisie dans rech_escale stockes en session par l_escales
               global $sess_enum, $sess_earr, $sess_edep, $sess_ebat, $sess_earm, $sess_eaff, $sess_eaut, $sess_eremorq ;
               global $sess_annee_en_cours;
               // Controle et transformation date arrive et dpart dans la cas ou on vient du choix Chercher
               if ( !empty($sess_earr) && !$sess_earr = isOkDate($sess_earr , 0 , 0) ){
                 $mes.= "<br>Date d'arrive invalide" ;
               }
               if ( !empty($sess_edep) && !$sess_edep = isOkDate($sess_edep, 23 , 59) ){
                  $mes.= "<br>Date de dpart invalide" ;
               }
               if ( $mes !="" ){
                 include ( "./header.php") ;
                 ?>
                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">
                    <tr>
                       <td align="center">
                         <?php echo $mes ;
                            echo "<br><a href=\"javascript:history.back()\">Retour</a>" ;
                         ?>
                      </td>
                    </tr>
                  </table>
               <?php
               include ( "./footer.php") ;
               exit();
             }

               //********************************************************************
               $this->requete    = "SELECT ".$this->table.".id,
                                            ".T_BATEAUX.".nom AS bateau
                                            FROM ".$this->table ;
               // Requete selon critres de tri
               $this->requete   .= " LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id ";
               $this->requete   .= " LEFT JOIN ".T_QUAIS." ON quai1=".T_QUAIS.".id ";
               switch ( $champ ) {
                  case "aff" :    // affreteur
                      $this->requete   .= "LEFT JOIN ".T_TIERS." ON id_aff=".T_TIERS.".id";
                  break;
                  case "acc" :    //  accounting
                      $this->requete   .= "LEFT JOIN ".T_TIERS." ON id_acc=".T_TIERS.".id";
                  break;
                  case "aut" :    // autre intervenant
                      $this->requete   .= "LEFT JOIN ".T_TIERS." ON id_aut=".T_TIERS.".id";
                  break;
                  default :          // armateur
                      $this->requete   .= "LEFT JOIN ".T_TIERS." ON id_arm=".T_TIERS.".id";
                  break;
               }
               if ( $t == "a" ) {
                 //Tenir compte de l'anne si escales arrives
                 $this->requete   .= " WHERE (status ='".$t."' AND ".$this->table.".num LIKE '".$this->ANNEE."%')"; //  tient compte de l'anne selectionne
                 $this->texte_req = "Liste des escales arrives" ;
               } else {
                 // Ne pas tenir compte de l'anne si escales futures ou annule
                 if ( $t == "fa" ) {
                    // Escales futures annules
                    $this->requete   .= " WHERE (status='f' AND annule='o')";
                    $this->texte_req = "Liste des escales futures annules" ;
                 }else {
                    // Escales futures
                    $this->requete   .= " WHERE status='f' AND annule!='o' ";
                    $this->texte_req = "Liste des escales futures";
                 }
               }
               // Rajout des critres de slection
               if ( $sess_enum != "") {
                  $this->requete   .= " AND num LIKE '%$sess_enum%'";
               }
               if ( $sess_eremorq != "") {
                  $this->requete   .= " AND remorq LIKE '%$sess_eremorq%'";
               }
               if ( $sess_earr != "" && $sess_edep == "" ) {
                  $this->requete   .= " AND arrivee >= '$sess_earr'";
               }
               if ( $sess_earr == "" && $sess_edep != "" ) {
                  $this->requete   .= " AND depart <= '$sess_edep'";
               }
               if ( $sess_earr != "" && $sess_edep != "" ) {
                  $this->requete   .= " AND  (arrivee >= '$sess_earr' AND depart <= '$sess_edep')";
               }
               if ( $sess_ebat != "") {
                  $this->requete   .= " AND id_bateau = '$sess_ebat'";
               }
               if ( $sess_earm != "") {
                  $this->requete   .= " AND id_arm = '$sess_earm'";
               }
               if ( $sess_eaff != "") {
                  $this->requete   .= " AND id_aff = '$sess_eaff'";
               }
               if ( $sess_eaut != "") {
                  $this->requete   .= " AND id_aut = '$sess_eaut'";
               }

               // fin de la requete
               $champ == "" ? $champ = "arrivee" : nul();
               $tri   == "" ? $tri = "DESC" : nul();
               ($champ=="arm" || $champ=="aff" || $champ=="acc" || $champ=="aut") ? $champ = "compagnie" : nul() ;

               $this->requete.= " ORDER BY $champ $tri" ;

       //  echo $this->requete ."<br>";
      }
      //**************************************  AFFICHAGE
      function affiche($page, $total, $nbpp, $p0="c" , $tesc="a" ){
               global $usr_droits,$boarding_agent;
               $colspan = 11;
               //  Titre
               echo '<table id="titreliste" width="100%" border="0" cellspacing="0" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <td width="25%" align="left" >&nbsp;</td>';
               echo '    <th width="50%" align="center">'.$this->texte_req.'</th>';
               echo '    <td width="25%" align="right">&nbsp;</td>';
               echo '  </tr>';
               echo '</table>';

               //  En-tete
               echo '<table id="liste" width="100%" border="0" cellspacing="1" cellpadding="0" align="center">';
               echo '  <tr align="center">';
               echo '    <th align="left" width="5%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=num">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=num">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         Num</th>';
               echo '    <th align="center" width="3%" valign="top">M</th>';
               echo '    <th align="left" width="7%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=arrivee">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=arrivee">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         <br />Arrive</th>';
               echo '    <th align="left" width="7%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=depart">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=depart">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         <br />Dpart</th>';
               echo '    <th align="left" width="13%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=bateau">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=bateau">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         <br />Bateau</th>';
               echo '    <th align="left" width="15%" valign="top"><br />Commentaire</th>';
               echo '    <th align="left" width="14%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=arm">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=arm">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         <br />Armateur</th>';
               echo '    <th align="left" width="14%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=aff">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=aff">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         <br />Affrteur</th>';
               echo '    <th align="left" width="12%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=aut">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=aut">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         <br />Intervenant</th>';
               echo '    <th align="left" width="12%" valign="top">
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=ASC&champ=quai1">
                         <img src="./images/ico_asc.gif" width="15" height="12" border="0" alt="Tri ascendant"></a>
                         <a href="./l_escales.php?=SID&tesc='.$tesc.'&tri=DESC&champ=quai1">
                         <img src="./images/ico_desc.gif" width="15" height="12" border="0" alt="Tri descendant"></a>
                         <br />Quai 1</th>';
               //echo '    <th align="left" width="5%" valign="top"><br />Remorqueur</th>';
               echo'     <th align="center" width="5%" valign="top">&nbsp;</th>';
               echo '  </tr>';

               echo '<tbody>';
               // affichage lignes
               $debut = ($page - 1 ) * $nbpp ;
               $result = mysqli_query( $this->connect, $this->requete." LIMIT $debut,$nbpp" );
               $i=1;
			   while ( $row = mysqli_fetch_object($result)) {
                       // Lecture escale
                       $esc = new escale($row->id , $this->connect);
                       $classe == "ligne1" ? $classe = "ligne2" : $classe = "ligne1" ;
                       $tesc=="a" && intval($esc->avarie)!=0 ?  $classe = "ligexpedie" : nul();
                       $esc->ba != 0 ? $title_lien = 'BA: '.$esc->ba_nom.' - Consulter ou modifier' : $title_lien = 'Consulter ou modifier';
                       echo '  <tr align="left" class="'.$classe.'">';
                       // modif du 05/0906 : affichage n d'ordre  la place du n d'escale future
					   // echo '    <td valign="top"><a href="./s_escale.php?=SID&id='.$esc->id.'&page='.$page.'&p0=m" title="'.$title_lien.'">'.$esc->num.'</a></td>';
                       if ($tesc=="f") {
					        echo '    <td valign="top" align="right"><a href="./s_escale.php?=SID&id='.$esc->id.'&page='.$page.'&p0=m" title="'.$title_lien.'">'.$i.'</a>&nbsp;&nbsp;&nbsp;</td>';
                       echo '    <td valign="top" align="center"><a href="javascript:popup(\''.DIR_WS.'s_mail_escale.php?=SID&id_escale='.$esc->id.'\',\'mails\',\'1000\',\'800\',\'0\',\'0\',\'yes\',\'yes\')" title="Mails de l\'escale"><img src="./images/ico_mail2.gif" width="25" height="15" border="0" align="absmiddle" /></a></td>';
                       echo '    <td valign="top"><a href="./s_escale.php?=SID&id='.$esc->id.'&page='.$page.'&p0=m" title="'.$title_lien.'">'.format_date($esc->arrivee,"d").'</a></td>';
                       } else {
					        echo '    <td valign="top"><a href="./s_escale.php?=SID&id='.$esc->id.'&page='.$page.'&p0=m" title="'.$title_lien.'">'.$esc->num.'</a></td>';
                       echo '    <td valign="top" align="center"><a href="javascript:popup(\''.DIR_WS.'s_mail_escale.php?=SID&id_escale='.$esc->id.'\',\'mails\',\'1000\',\'800\',\'0\',\'0\',\'yes\',\'yes\')" title="Mails de l\'escale"><img src="./images/ico_mail2.gif" width="25" height="15" border="0" align="absmiddle" /></a></td>';
                       echo '    <td valign="top">'.format_date($esc->arrivee,"d").'</td>';
                       }
					        echo '    <td valign="top">'.format_date($esc->depart,"d").'</td>';
                       echo '    <td valign="top">'.$esc->bateau_nom.'</td>';
                       echo '    <td valign="top">'.set_col($esc->com,25).'</td>';
                       echo '    <td valign="top">'.set_col($esc->arm_nom,25).'</td>';
                       echo '    <td valign="top">'.set_col($esc->aff_nom,25).'</td>';
                       echo '    <td valign="top">'.set_col($esc->aut_nom,14).'</td>';
                       echo '    <td valign="top">'.set_col($esc->quai1_nom,10).'</td>';
                       //echo '    <td valign="top">'.set_col($esc->remorq,8).'</td>';
                  if ( $usr_droits == "admin" ) {
                       echo '    <td valign="top"align="center"><a href="./supp_enreg.php?=SID&p0=escale&id='.$esc->id.'&page='.$page.'&tesc='.$tesc.'"><img src="./images/ico_supp.gif" width="20" height="16" border="0" alt="Supprimer cette escale"></a></td>';
                  } else {
                       echo '    <td valign="top">&nbsp;</td>';
                  }
                       echo '  </tr>';

                      // echo '  <tr valign="bottom"><td colspan="'.$colspan.'"><hr /></td></tr>';
                  $i++;
			   }
               echo '</tbody>';
               mysqli_free_result($result);
               $nbpages = @ceil($total/$nbpp) ;
               echo '<tfoot>';
               if ( $total > 0 ) {
                  echo '  <tr valign="bottom">';
                  echo '    <td colspan="'.$colspan.'">';
                  echo '              '.$total.' escales / '.$this->nbEnreg($tesc).' - Page '.$page.'/'.$nbpages.' &nbsp;&nbsp;&nbsp;>>>>&nbsp;&nbsp;&nbsp;';
                  for ( $i = 1 ; $i <= $nbpages ; $i++ ) {
                     echo '     <a href="l_escales.php?=SID&page='.$i.'&p0='.$p0.'&tesc='.$tesc.'">'.$i.'</a>&nbsp; ';
                  }
                  echo '    </td>';
                  echo '  </tr>';
                  /*
                  echo '        <tr>';
                  echo '          <td colspan="'.$colspan.'">';
                  echo '              Nombre total d'escales : '.$this->nbEnreg();
                  echo '          </td>';
                  echo '        </tr>';
                  */
                }
                else {
                   echo '  <tr height="200">';
                   echo '     <td align="center" colspan="'.$colspan.'">';
                   echo '        Aucune escale.</td>';
                   echo '  </tr>';
                }
                  echo '      </td>';
                  echo '   </tr>';
                  echo '</table>';
                  echo '</tfoot>';
      }

      //**************************************  INSERTION
      function inserer($num,$prov,$dest,
                       $arrivee,$arr_ferie,$arr_precis,
                       $depart,$dep_ferie,$dep_precis,
                       $harr_agent,$hdep_agent,
					        $duree,$id_bateau,
                       $id_arm,$id_aff,$id_acc,$id_aut,$remorq,$quai1,$quai2,$quai3,
                       $shift,$carg,$qte,$assur,$sout,$slop,$avarie,$via,$ba,$ba_nom,$scan,$rep_scan,$com,$status,$sof_scan)   {

               $query ="INSERT INTO ".$this->table." (
                        num,
                        prov,
                        dest,
                        arrivee,
                        arr_ferie,
                        arr_precis,
                        depart,
                        dep_ferie,
                        dep_precis,
                        duree,
						      harr_agent,
						      hdep_agent,
                        id_bateau,
                        id_arm,
                        id_aff,
                        id_acc,
                        id_aut,
                        remorq,
                        quai1,
                        quai2,
                        quai3,
                        shift,
                        carg,
                        qte,
                        assur,
                        sout,
                        slop,
                        avarie,
                        via,
                        ba,
                        ba_nom,
                        scan,
                        rep_scan,
                        com,
                        status,
						sof_scan
						)
                        VALUES (
                        '$num',
                        '$prov',
                        '$dest',
                        '$arrivee',
                        '$arr_ferie',
                        '".escape($arr_precis)."',
                        '$depart',
                        '$dep_ferie',
                        '".escape($dep_precis)."',
                        '".escape($duree)."',
                        '$harr_agent',
                        '$hdep_agent',
                        '$id_bateau',
                        '$id_arm',
                        '$id_aff',
                        '$id_acc',
                        '$id_aut',
                        '".escape($remorq)."',
                        '$quai1',
                        '$quai2',
                        '$quai3',
                        '".escape($shift)."',
                        '".escape($carg)."',
                        '".escape($qte)."',
                        '$assur',
                        '$sout',
                        '$slop',
                        '$avarie',
                        '".escape($via)."',
                        '$ba',
                        '".escape($ba_nom)."',
                        '$scan',
                        '".escape($rep_scan)."',
                        '".escape($com)."',
                        '$status', '".escape($sof_scan)."' )" ;

          // echo "Requete :<br>$query<br>";

                    if ( !$ok = mysqli_query( $this->connect, $query ) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  MODIFCATION
      function modifier($id,$prov,$dest,
                        $arrivee,$arr_ferie,$arr_precis,
                        $depart,$dep_ferie,$dep_precis,
                        $harr_agent,$hdep_agent,
					         $duree,$id_bateau,
                        $id_arm,$id_aff,$id_acc,$id_aut,$remorq,$quai1,$quai2,$quai3,
                        $shift,$carg,$qte,$assur,$sout,$slop,$avarie,$via,$ba,$ba_nom,$scan,$rep_scan,$com,$sof_scan)   {

               $query ="UPDATE ".$this->table." SET
                         prov= '$prov',
                         dest= '$dest',
                         arrivee= '$arrivee',
                         arr_ferie= '$arr_ferie',
                         arr_precis='".escape($arr_precis)."',
                         depart= '$depart',
                         dep_ferie= '$dep_ferie',
                         dep_precis='".escape($dep_precis)."',
                         duree= '".escape($duree)."',
                         harr_agent= '".escape($harr_agent)."',
                         hdep_agent= '".escape($hdep_agent)."',
                         id_bateau= '$id_bateau',
                         id_arm= '$id_arm',
                         id_aff= '$id_aff',
                         id_acc= '$id_acc',
                         id_aut= '$id_aut',
                         remorq= '".escape($remorq)."',
                         quai1= '$quai1',
                         quai2= '$quai2',
                         quai3= '$quai3',
                         shift= '".escape($shift)."',
                         carg= '".escape($carg)."',
                         qte= '".escape($qte)."',
                         assur= '$assur',
                         sout= '$sout',
                         slop= '$slop',
                         avarie= '$avarie',
                         via= '".escape($via)."',
                         ba='$ba',
                         ba_nom= '".escape($ba_nom)."',
                         scan='$scan',
                         rep_scan= '".escape($rep_scan)."',
                         com= '".escape($com)."',
						 sof_scan = '".escape($sof_scan)."'
                        WHERE id = '$id'" ;
 
           //echo "Requete :<br>$query<br>";exit;

                    if ( !$ok = mysqli_query( $this->connect, $query ) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }
				//		 exit();
                    return $ok  ;
      }
      //**************************************  Suppression
      function supprimer($num){
               // on sauvegarde l'enregistrement avant de l'effacer
               if ( !$this->sauvegardeEnreg() )  {
                 // echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                 return false ;
               }
               // Suppression : ajout test PhR 08/07/09
					//echo $this->num.' : '.$this->status.'<br>';
					//exit();
               if ($this->status=='a') {
               	// Suppression relle
	               $ok = mysqli_query( $this->connect, "DELETE FROM ".$this->table." WHERE id LIKE '$num'"  );
					} else {
						// Maj champ annule
	               $ok = mysqli_query( $this->connect, "UPDATE ".$this->table." SET annule='o' WHERE id LIKE '$num'" );
					}

               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }
      //**************************************  SAUVEGARDE ENREGISTREMENT AVANT EFFACEMENT
      function sauvegardeEnreg()   {
               global $usr_id, $usr_nom, $usr_prenom, $usr_log,
                      $usr_pw, $usr_droits, $usr_site, $sess_annee_en_cours;

               $query ="INSERT INTO ".$this->table."_supp (
                        date_supp,
                        usr_id,
                        usr_nom,
                        usr_prenom,
                        usr_log,
                        usr_pw,
                        usr_droits,
                        usr_site,
                        sess_annee_en_cours,
                        id,
                        num,
                        prov,
                        dest,
                        arrivee,
                        arr_ferie,
                        arr_precis,
                        depart,
                        dep_ferie,
                        dep_precis,
                        duree,
						      harr_agent,
						      hdep_agent,
                        id_bateau,
                        id_arm,
                        id_aff,
                        id_acc,
                        id_aut,
                        remorq,
                        quai1,
                        quai2,
                        quai3,
                        shift,
                        carg,
                        qte,
                        assur,
                        sout,
                        slop,
                        avarie,
                        via,
                        ba,
                        ba_nom,
                        scan,
                        rep_scan,
                        com,
                        status)
                        VALUES (
                        '".gmdate("Y-m-d H:i:s")."',
                        '$usr_id',
                        '".escapeRuntime($usr_nom)."',
                        '".escapeRuntime($usr_prenom)."',
                        '".escapeRuntime($usr_log)."',
                        '$usr_pw',
                        '".escapeRuntime($usr_droits)."',
                        '".escapeRuntime($usr_site)."',
                        '$sess_annee_en_cours',
                        '$this->id',
                        '$this->num',
                        '$this->prov',
                        '$this->dest',
                        '$this->arrivee',
                        '$this->arr_ferie',
                        '".escapeRuntime($this->arr_precis)."',
                        '$this->depart',
                        '$this->dep_ferie',
                        '".escapeRuntime($this->dep_precis)."',
                        '".escapeRuntime($this->duree)."',
                        '".escapeRuntime($this->harr_agent)."',
                        '".escapeRuntime($this->hdep_agent)."',
                        '$this->id_bateau',
                        '$this->id_arm',
                        '$this->id_aff',
                        '$this->id_acc',
                        '$this->id_aut',
                        '".escapeRuntime($this->remorq)."',
                        '$this->quai1',
                        '$this->quai2',
                        '$this->quai3',
                        '".escapeRuntime($this->shift)."',
                        '".escapeRuntime($this->carg)."',
                        '".escapeRuntime($this->qte)."',
                        '$this->assur',
                        '$this->sout',
                        '$this->slop',
                        '$this->avarie',
                        '".escapeRuntime($this->via)."',
                        '$this->ba',
                        '".escapeRuntime($this->ba_nom)."',
                        '$this->scan',
                        '".escapeRuntime($this->rep_scan)."',
                        '".escapeRuntime($this->com)."',
                        '$this->status')" ;

           //echo "Requete :<br>$query<br>";

                    if ( !$ok = @mysqli_query( $this->connect, $query ) )  {
                       echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                    }

                    return $ok  ;
      }
      //**************************************  Recherche suivant pour parcours table
      function litSuivant($id){
               global $pr_html ;
               global $cnx ;
               // On rcupre l'enregistrement dont le num correspond au suivant
               $query = "SELECT id FROM ".$this->table." WHERE id>'$id' LIMIT 1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object($result) ;
               // on vrifie si c'est le dernier enregistrement
               if (mysqli_num_rows($result) == 0 ) {
                  $suiv = $id  ;
               }
               else {
                  $suiv = $row->id ;
               }
               return $suiv ;
      }
      //**************************************  Recherche precedent pour parcours table
      function litPrecedent($id){
               global $pr_html ;
               global $cnx ;
               // On rcupre l'enregistrement dont le num correspond au precedent
               $query = "SELECT id FROM ".$this->table." WHERE id<'$id' ORDER BY id DESC LIMIT 1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object($result) ;
               // on vrifie si c'est le premier enregistrement
               if (mysqli_num_rows($result) == 0 ) {
                  $prec = $id  ;
               }
               else {
                  $prec = $row->ref ;
               }
               return $prec ;
      }
      //************************************** Verif si existe
      function existe($id) {
           $query = "SELECT id FROM ".$this->table." WHERE id='$id'";
           $result = mysqli_query( $this->connect, $query );
           if ( mysqli_num_rows($result) > 0 ) { return true ; }
           else { return false ; }
      }
      //************************************** Comptage nb total d'enreg
      function nbEnreg($tesc="a") {
           $query = "SELECT id FROM ".$this->table." WHERE status='$tesc'";
           $result = mysqli_query( $this->connect, $query );
           $nb = mysqli_num_rows ($result) ;
           mysqli_free_result($result) ;
           return $nb ;
      }
      //************************************** Suppression de tous les enregistrements
      function vider() {
           $query = "DELETE FROM ".$this->table."";
           $result = mysqli_query( $this->connect, $query );
      }
      //************************************** Recherche de l'id suivant
      function getNextId(){
               $query = "SELECT id FROM ".$this->table." ORDER BY id DESC LIMIT 0,1" ;
               $result = mysqli_query( $this->connect, $query );
               $row = mysqli_fetch_object ($result) ;
               return $row->id + 1 ;
      }
      //************************************** Cration du numro d'escale
      function getNextNum($t){
               // Martinique ou guadeloupe
			   
			  /* insr
			  el 14/01 en remplacement de ce code qui fonctionnait :
			    global $usr_site;
               $usr_site == "Martinique" ? $num = "" : $num = "G" ;
               if ( $usr_site != "Martinique" && $usr_site != "Guadeloupe" ) {
			  
			  */
               global $usr_site;
                if ($usr_site == "Martinique" ) {
				 $num = "";
		      } elseif ($usr_site == "Guadeloupe" )  { 
				 $num = "G";
			  } elseif ($usr_site == "Oss97" )  { 
				 $num = "O";
			 } elseif ($usr_site == "Oss97_guad" )  { 
				 $num = "OG";
			  } else {
			     $num = "A";
			  } 
               if ( $usr_site != "Martinique" && $usr_site != "Guadeloupe" && $usr_site != "Antilles"  && $usr_site != "Oss97" && $usr_site != "Oss97_guad" ) {
                 echo "Problme pour crer le n d'escale.<br />
                       Le site n'est pas correctement dfini car il n'est ni Martinique,ni Antilles Shipping, ni Oss97, ni Guadeloupe<br />
                       <br />Cette escale ne sera pas enregistre.<br /><br />
                       <a href=\"".DIR_WS."logout.php?=SID\">Connectez-vous  nouveau et ressayez.</a>";  // Cette escale sera enregistre avec le prfixe 'INCONNU'
                       exit();
                 $num = "INCONNU" ;
               }

               // Anne
               $num .= "2" . date("y") ."." ; // Pour n sous forme 210. pour 2010 // Phr 27/12/09
               //$num .= "2".substr( date("y"), 1, 1 ) ."." ;
               // N d'ordre
               switch ($t) {
                  case "a" :
                     $query = "SELECT arrivee FROM ".T_COMPTEURS."" ;
                     $result = mysqli_query( $this->connect, $query );
                     $row = mysqli_fetch_object ($result) ;
                     $n = $row->arrivee + 1;
                     mysqli_free_result($result) ;
                     $num .= pre_fill ( $n , 3 , "0" );
                  break;

                  case "f" :
                     $query = "SELECT future FROM ".T_COMPTEURS."" ;
                     $result = mysqli_query( $this->connect, $query );
                     $row = mysqli_fetch_object ($result) ;
                     $n = $row->future + 1;
                     mysqli_free_result($result) ;
                     $num .= "A".pre_fill ( $n , 5 , "0" );
                  break;
               }
               return $num;
      }

      //************************************** maj du compteur de numeros de la table COMPTEURS
      function updateCompteur($t){
              if ( $t == "f" ) {
                  $query = "UPDATE ".T_COMPTEURS." SET future=future + 1 ";
              } else {
                  $query = "UPDATE ".T_COMPTEURS." SET arrivee=arrivee + 1 ";
              }
              return mysqli_query( $this->connect,$query );
      }
      //************************************** Transformation d'une escale future en arrive
      function transFutArr($id, $num){
              $query = "UPDATE ".$this->table." SET num='$num', status='a' WHERE id='$id' ";

              if ( !$ok = mysqli_query( $this->connect, $query) )  {
                  echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
              }
              return $ok;
      }
      //************************************** Transformation d'une escale future en annule
      function transFutAnnule($id, $num){
              $query = "UPDATE ".$this->table." SET annule='o' WHERE id='$id' ";

              if ( !$ok = mysqli_query( $this->connect, $query ) )  {
                  echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
              }
              return $ok;
      }
      /*******************************************************************
	  *  Dcalage des n d'escales arrivees suivantes
	  *  de la meme anne
	  *  suite  la suppression de l'escale de n $num
	  *  -  $num = numero de l'escale (dej) supprime)
	  *  -  $tesc = type d'escale : a ou f
	  *  -  $escale : objet escale supprime
      *******************************************************************/
	 // function decalerNumerosSuivants($num, $tesc, $ANNEE){
      function decalerNumerosSuivants($escale){
              $query = "SElECT id, num, status FROM ".$this->table."
			            WHERE num > '".$escale->num."'
						  AND num LIKE '".$escale->ANNEE."%'
					      AND status = '".$escale->status."'
						ORDER BY num
						";
      //  echo $query."<br>";
		      $result = mysqli_query( $this->connect, $query );
		      $ok = true;
			  while ( $row = mysqli_fetch_object($result)) {
			     $new_num = substr($row->num, 0, -3).pre_fill( substr($row->num, -3) - 1 , 3 , "0" );
      //   echo $row->num." --> ". $new_num."<br>";
				 $query = "UPDATE ".$this->table." SET
				           num = '".$new_num."'
			               WHERE id  = '".$row->id."'
						";
				if ( !$ok = mysqli_query( $this->connect, $query ) )  {
                  echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                }
			  }

			  // MAJ compteur escales
			    // on doit normalement utiliser uniquement les arrives, mais en cas ...
			  if ( $escale->status == "f" ) {
                 $query = "UPDATE ".T_COMPTEURS." SET future=future - 1 ";
              } else {
                 $query = "UPDATE ".T_COMPTEURS." SET arrivee=arrivee - 1 ";
              }
			  if ( !$ok_compteur = mysqli_query( $this->connect, $query ) )  {
			     if ( $ok ) {
			        echo "L'escale ".$escale->num." a bien t supprime <br>
                    et les numros dcals mais la prochaine escale<br>
                    ne portera pas la bon numro car le compteur n'a pas pu tre mis  jour<br>";
			        echo "Err sql : ".mysqli_errno()." : ".mysqli_error()."<br>"; exit();
                 }
              }
              return $ok;
      }

}  // Fin classe

?>