<?php 
/*******************************   U S E R   ****************************/
class user  {
      var $connect;
      var $table;      // Nom de la table

      var $id;
      var $nom;
      var $prenom;
      var $log;
      var $pw;
      var $droits;
      var $site;

      public function __construct( $numero , $cnx ){
               $this->table = "user";
               $this->connect  = $cnx;
               $this->id = $numero;
               if ( $numero !=0 && $numero !="" ) {
				   
                    $result = mysqli_query($this->connect, "SELECT * FROM ".$this->table." WHERE usr_id = $numero");
                    $row=mysqli_fetch_object($result) ;
                            $this->nom       = $row->usr_nom       ;
                            $this->prenom    = $row->usr_prenom    ;
                            $this->log       = $row->usr_log       ;
                            $this->pw        = $row->usr_pw        ;
                            $this->droits    = $row->usr_droits    ;
                            $this->site      = $row->usr_site      ;
               }
      }

      // *********************************** Verification du mot de passe saisi
      function login_ok( $flog, $fmp ) {  
          $query = "SELECT usr_id,usr_nom,usr_prenom,usr_log,usr_pw,usr_droits,usr_site FROM ".$this->table." WHERE usr_pw = '".$fmp."' AND usr_log ='$flog'";
          
		  $result = mysqli_query($this->connect, $query);
		       if ( $row = mysqli_fetch_object($result) ) {
                  $this->id        = $row->usr_id ;
                  $this->nom       = $row->usr_nom       ;
                  $this->prenom    = $row->usr_prenom    ;
                  $this->log       = $flog ;
                  $this->pw        = $row->usr_pw;
                  $this->droits    = $row->usr_droits ;
                  $this->site      = $row->usr_site ;

                  mysqli_free_result($result);
                  return true ;
               }
               else {
                  return false ;
               }
      }
      //************************************** Verification log/pw unique
      /*  mode : creation (c) ou modifiactaion (m)
      *   log  : login saisi
      *   pw   : mot de passe saisi
      * cette fonction valide ou nom un couple log/pw en fonction des cas
      * - met  jour le mot de passe dans l'objet user si ok
      * - renvoie un message d'erreur si non valides
      *******************************************************************/
      function is_ok_pwlog( $mode, $log, $mp ) {
           $mes = "" ;
           switch ( $mode ) {
              case "m" :
                 if ( $mp == "" )  {  $mp = $this->pw ; }  else { $mp = md5($mp) ;  }
                 if ( $log == "" ) {  $log = $this->log ; }
                 if ( $mp != $this->pw ) {   // nouveau mp ----> existe deja ?
                     $query = " SELECT usr_pw FROM ".$this->table." WHERE usr_pw='$mp'";
                     $result = mysqli_query( $this->connect, $query);
                     if ( mysqli_num_rows($result) > 0 ) {
                        $mes .= "<b>Le mot de passe indiqu existe dj.</b><br>" ;
                     }
                 }
                 if ( $log != $this->log ) {   // nouveau log ----> existe deja ?
                     $query = " SELECT usr_log FROM ".$this->table." WHERE usr_log='$log'";
                     $result = mysqli_query( $this->connect, $query );
                     if ( mysqli_num_rows($result) > 0 ) {
                        $mes .= "<b>Le nom d'utilisateur (log) indiqu existe dj.</b><br>" ;
                     }
                 }
                 break;

              case "c" :
                     $mp = md5($mp) ;
                     // mp existe deja ?
                     $query = " SELECT usr_pw FROM ".$this->table." WHERE usr_pw='$mp'";
                     $result = mysqli_query( $this->connect, $query);
                     if ( mysqli_num_rows($result) > 0 ) {
                        $mes .= "<b>Le mot de passe indiqu existe dj.</b><br>" ;
                     }
                     // log existe deja ?
                     $query = " SELECT usr_log FROM ".$this->table." WHERE usr_log='$log'";
                     $result = mysqli_query( $this->connect, $query );
                     if ( mysqli_num_rows($result) > 0 ) {
                        $mes .= "<b>Le nom d'utilisateur (log) indiqu existe dj.</b><br>" ;
                     }
                 break;
              default :
                 $mes.= "On est dans le default de la fonction is_ok_pwlog et on ne devrait pas !!" ;
           }   // Fin SWITCH
           if ( $mes == "" ) {
                $this->pw  = $mp ;
                $this->log = $log ;
           }
           else {
                return $mes ;
           }
      }

      //**************************************  INSERTION D'UN UTILISATEUR
      function inserer_user($flog,$fnom,$fprenom,$fpw,$fdroits,$fsite)  {

               $query ="INSERT INTO ".$this->table." (
                        usr_nom,
                        usr_prenom,
                        usr_log,
                        usr_pw,
                        usr_droits,
                        usr_site)
                        VALUES (
                        '".escape($fnom)."',
                        '".escape($fprenom)."',
                        '".escape($flog)."',
                        '".escape($fpw)."',
                        '$fdroits',
                        '$fsite')";

                    return $ok = mysqli_query( $this->connect, $query) ;
      }
      //**************************************  MODIFCATION UTILISATEUR
      function modifier_user($id,$fnom,$fprenom,$flog,$fpw,$fdroits,$fsite) {

               $query ="UPDATE ".$this->table." SET
                        usr_nom = '".escape($fnom)."',
                        usr_prenom = '".escape($fprenom)."',
                        usr_log = '$flog',
                        usr_pw = '$fpw',
                        usr_droits = '$fdroits',
                        usr_site = '$fsite'
                        WHERE usr_id = '$id'" ;

                    return $ok = mysqli_query( $this->connect, $query ) ;
      }
      //**************************************  Suppression
      function supprimer($num){
               $ok = mysqli_query( $this->connect, "DELETE FROM ".$this->table." WHERE usr_id LIKE '$num'" );
               if ( $ok ) {
                 return true ;
               }
               else {
                 return false ;
               }
      }
      //**************************************  MODIFICATION MOT DE PASSE
      function modifier_pw( $id, $fpw ) {
               $query ="UPDATE ".$this->table." SET
                        usr_pw = '$fpw'
                        WHERE usr_id = '$id'" ;
                    return $ok = mysqli_query( $this->connect, $query ) ;
      }
      //**************************************  AFFICHAGE DES UTILISATEURS
      function aff_user(){
               // Titre
               print ("<TABLE id=\"titreliste\" WIDTH=\"100%\" BORDER=0 CELLSPACING=1 CELLPADDING=2 align=\"center\">");
               Print ("  <TR ALIGN=\"CENTER\">");
               Print ("    <td width=\"25%\" align=\"left\" ><a href=\"./s_user.php?=SID&p0=c\">Crer un utilisateur</a></td>");
               Print ("    <th width=\"50%\" align=\"center\">Liste des utilisateurs</th>");
               Print ("    <td width=\"25%\" align=\"right\">&nbsp;</td>");
               Print ("  </TR>");
               Print ("</table>");
               // prsentation des rubriques du tableau.
               print ("<TABLE id=\"liste\" WIDTH=\"100%\" BORDER=0 CELLSPACING=1 CELLPADDING=2 align=\"center\">");
               Print ("  <TR ALIGN=\"CENTER\">");
               Print ("    <th ALIGN=\"left\" VALIGN=\"TOP\" WIDTH=\"30%\">Nom</th>");
               Print ("    <th ALIGN=\"left\" VALIGN=\"TOP\" WIDTH=\"30%\">Prnom</th>");
               Print ("    <th ALIGN=\"left\" VALIGN=\"TOP\" WIDTH=\"10%\">Identifiant</th>");
               Print ("    <th ALIGN=\"left\" VALIGN=\"TOP\" WIDTH=\"10%\">Droits</th>");
               Print ("    <th ALIGN=\"left\" VALIGN=\"TOP\" WIDTH=\"10%\">Site</th>");
               Print ("    <th ALIGN=\"center\" VALIGN=\"TOP\" WIDTH=\"10%\">Supprimer</th>");
               Print ("  </TR>");
               // affichage des donnes de la table
               $query = "SELECT usr_id,usr_nom,usr_prenom,usr_log,usr_pw,usr_droits,usr_site FROM ".$this->table." ORDER BY usr_nom ASC" ;
               $result= mysqli_query( $this->connect, $query);
               while ( $row = mysqli_fetch_object($result)) {
                       print ("  <TR ALIGN=\"LEFT\">");
                       print ("    <TD ALIGN=\"LEFT\" VALIGN=\"TOP\"><A HREF=\"./s_user.php?=SID&id=".$row->usr_id."&p0=m\" title=\"Accder au dtail pour consulter ou modifier\">$row->usr_nom</a></TD>");
                       print ("    <TD ALIGN=\"LEFT\" VALIGN=\"TOP\">$row->usr_prenom</TD>");
                       print ("    <TD ALIGN=\"LEFT\" VALIGN=\"TOP\">$row->usr_log</TD>");
                       print ("    <TD ALIGN=\"LEFT\" VALIGN=\"TOP\">$row->usr_droits</TD>");
                       print ("    <TD ALIGN=\"center\" VALIGN=\"TOP\">$row->usr_site</TD>");
                       print ("    <TD ALIGN=\"center\" VALIGN=\"TOP\"><a href=\"./supp_enreg.php?=SID&p0=user&id=".$row->usr_id."\"><img src=\"./images/ico_supp.gif\" width=\"20\" height=\"16\" border=\"0\" alt=\"Supprimer cet utilsateur\"></a></TD>");
                       print ("  </TR>");
               }
               mysqli_free_result($result);
               print ("</TABLE>");
               print ("</TR>");
      }

      //************************************** Comptage nb total d'enreg
      function nbEnreg() {
           $query = "SELECT usr_id FROM ".$this->table."";
           $result = mysqli_query( $this->connect, $query );
           $nb = mysqli_num_rows ($result) ;
           mysqli_free_result($result) ;
           return $nb ;
      }

}   /// Fin classe User
//***************************************************************************************************
?>