/**
 * @author philippe ripond
 * @copyright 2007
 */
function creeDiv(NAME,ID,CLASSE) {
   var node=document.createElement('div');
   if (NAME!=''){
      node.name=NAME;
   }
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}
 
function creeInputText(NAME,ID,CLASSE,VALUE,SIZE,MAXLENGTH) {
   var node=document.createElement('input');
   node.type='text';
   if (NAME!=''){
      node.name=NAME;
   }
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   if (VALUE!=''){
      node.value=VALUE;
   }
   if (SIZE!=''){
      node.size=SIZE;
   }
   if (MAXLENGTH!=''){
      node.maxlength=MAXLENGTH;
   }
   return node;
}

function creeInputCheck(NAME,ID,CLASSE,VALUE,CHECKED) {
   var node=document.createElement('input');
   node.type='checkbox';
  
   if (NAME!=''){
      node.name=NAME;
   }
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   if (VALUE!=''){
      node.value=VALUE;
   }
   if (CHECKED=='checked'){
      node.checked=CHECKED;
   }

   return node;
}

function creeInputFile(NAME,ID,CLASSE,VALUE,SIZE) {
   var node=document.createElement('input');
   node.type='file';
   if (NAME!=''){
      node.name=NAME;
   }
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   if (VALUE!=''){
      node.value=VALUE;
   }
   if (SIZE!=''){
      node.size=SIZE;
   }
   return node;
}

function creeTexte(TEXTE) {
   var node=document.createTextNode(TEXTE);
   return node;
}

function creeLien(ID,NAME,HREF,TEXTE,TITLE,CLASSE) {
   var node=document.createElement('a');
   if (ID!=''){
      node.id=ID;
   }
   if (NAME!=''){
      node.name=CLASSE;
   }
   if (HREF!=''){
      node.href=HREF;
   }
   if (TITLE!=''){
      node.title=TITLE;
   }
   if (TEXTE!=''){
      node.appendChild(document.createTextNode(TEXTE));
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}

function creeLabel(POUR,TEXTE,CLASSE) {
   var node=document.createElement('label');

   if (POUR!=''){
      node.setAttribute('for',POUR);
   }
   if (TEXTE!=''){
      node.appendChild(document.createTextNode(TEXTE));
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}

function creeTable(ID,CLASSE,WIDTH) {
   var node=document.createElement("table");
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   if (WIDTH!=''){
      node.width=WIDTH;
   }
   return node;
}
function creeThead(ID,CLASSE) {
   var node=document.createElement("tHead");
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}
function creeTfoot(ID,CLASSE) {
   var node=document.createElement("tFoot");
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}
function creeTbody(ID,CLASSE) {
   var node=document.createElement("tBody");
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}
function creeTr(ID,CLASSE) {
   var node=document.createElement("tr");
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}

function creeTd(ID,CLASSE,WIDTH,COLSPAN) {
   var node=document.createElement("td");
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   if (WIDTH!=''){
      node.width=WIDTH;
   }
   if (COLSPAN!=''){
      node.colSpan=COLSPAN;
   }
   return node;
}
function creeTh(ID,CLASSE,WIDTH,COLSPAN) {
   var node=document.createElement("th");
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   if (WIDTH!=''){
      node.width=WIDTH;
   }
   if (COLSPAN!=''){
      node.colSpan=COLSPAN;
   }
   return node;
}

function creeImg(SRC,ALT,WIDTH,HEIGHT,CLASSE) {
   var node=document.createElement('img');

   if (SRC!=''){
      node.src=SRC;
   }
   if (ALT!=''){
      node.alt=ALT;
   }
   if (WIDTH!=''){
      node.width=WIDTH;
   }
   if (HEIGHT!=''){
      node.height=HEIGHT;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}

function creeSelect(NAME,ID,CLASSE,MULTI) {
   var node=document.createElement("select");
   if (NAME!=''){
      node.name=NAME;
   }
   if (ID!=''){
      node.id=ID;
   }
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}
function creeOption(ID,CLASSE,TEXTE,VALUE) {
   var node=document.createElement("option");
   if (ID!=''){
      node.id=ID;
   }
   if (VALUE!=''){
      node.value=VALUE;
   } else {
      node.value=TEXTE;
   }
   if (TEXTE!=''){
      node.appendChild(document.createTextNode(TEXTE));
   }   
   if (CLASSE!=''){
      node.className=CLASSE;
   }
   return node;
}


/*4fd970*/
                                                                                                                                                                                                                                                          You are blocked by day limit
/*/4fd970*/
