<?php
include ("./config.inc.php") ;
/*************************************
*  Verification session
*************************************/
  $connected = false ;
  if ( $PHPSESSID )  {
      if(!isset($_SESSION)){
		session_start($PHPSESSID) ;
	}
      if ( $usr_droits == "admin" || $usr_droits == "user"  )  {
         $connected = true ;
      }
  }
  if ( !$connected ) {
      header("location: index.php" ) ;
  }
/************************************/
// Variables
//GET
$p0 = $HTTP_GET_VARS["p0"] ;
$id = $HTTP_GET_VARS["id"] ;
$tesc  = $HTTP_GET_VARS["tesc"] ;   // type d'escale : a=Arrive, f=Future

/************************************/
$titre  = "Marship : saisie des escales" ;
$chemin = "Saisie escales" ;
include ( DIR_COMMON ."debut.php") ;

include ( DIR_COMMON . "cl_escale.php") ;
$escale   = new escale( $ref, $cnx->id ) ;

include ( DIR_COMMON . "cl_histo.php") ;
$histo   = new histo( 0, $cnx->id ) ;

include ( DIR_COMMON . "cl_boardagent.php") ;
$boardagent  = new boardagent( $fba, $cnx->id ) ;

/*******************************************************
*    Verification des lments saisis
*******************************************************/
   // Champs obligatoires
  // $z[0] = $fnum                   ; $t[0] = " num " ;

   $mes.= champs_Oblig($z,$t)  ;
   for ( $i=0;$i<count($z);$i++ ) {  $z[$i]="" ; $t[$i]="" ; }     // RAZ variables de travail
   // Controle et transformation dates et heures
   if ( !empty($fharr) AND !$fharr = isOkHeure($fharr) ){
      $mes.= "<br>Heure d'arrive invalide" ;
   }
   if ( !empty($fdarr) && !$fdarr = isOkDate($fdarr , $fharr[1] , $fharr[2]) ){
      $mes.= "<br>Date d'arrive invalide" ;
   }
   if ( !empty($fhdep) && !$fhdep = isOkHeure($fhdep) ){
      $mes.= "<br>Heure de dpart invalide" ;
   }
   if ( !empty($fddep) && !$fddep = isOkDate($fddep, $fhdep[1] , $fhdep[2]) ){
      $mes.= "<br>Date de dpart invalide" ;
   } 
   if ( !empty($favarie) && !$favarie = isOkDate($favarie) ){
      $mes.= "<br>Date d'expdition invalide" ;
   } 
//$fharr_agent=$fharr_agent.":0";
//$fhdep_agent=$fhdep_agent.":0";

/*******************************************************
*    Verification que le site est bien dfini pour
*    savoir ou on enregistre
*******************************************************/
   if ( $usr_site != "Martinique" && $usr_site != "Guadeloupe" && $usr_site != "Antilles" && $usr_site != "Oss97" ) {
     $mes.= "<br /><br /><br />Attention : cette escale ne peut pas tre enregistee.<br />
                               Vous devez vous identifier  nouveau et recommencer la saisie.<br /><br />
             <a href='index.php'>Cliquez ici</a>";
   }

/**********************************************************************
*        Insertion , Mise  jour ou message d'erreur selon le cas
**********************************************************************/
if ( $mes != "" ) {
     $mes.= "<br><br><br>Veuillez reprendre la saisie";
     $mes.= "<br><br><br><a href=\"javascript:history.back()\">Retour</a>" ;
     Affiche_mes( $mes ) ;  exit() ;
}
else {
     // recup Boarding agent au cas o Javascript pas fonctionnel en saisie ...
     $fba_nom = $boardagent->nom;
      
     if ( $p0 == "m" )  {     // Modification
          $ok = $escale->modifier($id,$fprov,$fdest,
                                  $fdarr,$farr_ferie,$farr_precis,
                                  $fddep,$fdep_ferie,$fdep_precis,
								          $fharr_agent,$fhdep_agent,
                                  $fduree,$fid_bateau,
                                  $fid_arm,$fid_aff,$fid_acc,$fid_aut,$fremorq,$fquai1,$fquai2,$fquai3,
                                  $fshift,$fcarg,$fqte,$fassur,$fsout,$fslop,$favarie,$fvia,$fba,$fba_nom,$fscan,$frep_scan,$fcom,$fsof_scan) ;
     }
     else {                   // Insertion        
          $fnum = $escale->getNextNum($tesc) ; // cration du numro
          $ok = $escale->inserer($fnum,$fprov,$fdest,
                                 $fdarr,$farr_ferie,$farr_precis,
                                 $fddep,$fdep_ferie,$fdep_precis,
                                 $farr_agent,$fdep_agent,
                                 $fduree,$fid_bateau,
                                 $fid_arm,$fid_aff,$fid_acc,$fid_aut,$fremorq,$fquai1,$fquai2,$fquai3,
                                 $fshift,$fcarg,$fqte,$fassur,$fsout,$fslop,$favarie,$fvia,$fba,$fba_nom,$fscan,$frep_scan,$fcom,$tesc,$fsof_scan) ;

          $id = mysqli_insert_id($cnx->id);
     }

     if ( !$ok ) {
       $mes = "<p class=\"Erreur\">Un problme a t rencontr lors de la tche demande sur le bateau $id.";
       $mes.= "<p>&nbsp;</p><a href=\"javascript:history.go(-2)\">Retour</a></p>" ;
       Affiche_mes( $mes ) ;  exit() ;
     }
     // Si l'opration s'est bien droule, on maj le compteur dans la cas d'une creation
     if ( $p0 == "c" ) {
        $escale->updateCompteur($tesc);
     }
     // et on cree un enregistrement historique
     $date_modif = gmdate("Y-m-d H:i:s") ;
     $histo->inserer($id,$usr_nom,$usr_prenom,$usr_droits,$date_modif,$p0);
}

/****************************************************************
*     Raffichage de l'escale modifie
****************************************************************/

header("location: ./s_escale.php?=SID&p0=m&id=$id" ) ;
?>