$(function() { 
 
  // call the tablesorter plugin 
  $("table").tablesorter({ 
 
    // initialize zebra striping and filter widgets 
    widgets: ["zebra", "filter"], 
 
    // headers: { 5: { sorter: false, filter: false } }, 
 
    widgetOptions : { 
 
      // css class applied to the table row containing the filters & the inputs within that row 
      filter_cssFilter : 'tablesorter-filter', 
 
      // If there are child rows in the table (rows with class name from "cssChildRow" option) 
      // and this option is true and a match is found anywhere in the child row, then it will make that row 
      // visible; default is false 
      filter_childRows : false, 
 
      // Set this option to true to use the filter to find text from the start of the column 
      // So typing in "a" will find "albert" but not "frank", both have a's; default is false 
      filter_startsWith : false, 
 
      // Set this option to false to make the searches case sensitive 
      filter_ignoreCase : true, 
 
      // Delay in milliseconds before the filter widget starts searching; This option prevents searching for 
      // every character while typing and should make searching large tables faster. 
      filter_searchDelay : 300, 
 
      // See the filter widget advanced demo on how to use these special functions 
      filter_functions : {} 
 
    } 
// ,debug: true 
  }); 
 
});