<?php

ob_start();

include ("./config.inc.php") ;



define('FPDF_FONTPATH', DIR_COMMON.'font/');

require(DIR_COMMON.'fpdf.php');



/*************************************

*  Verification session

*************************************/

  $connected = false ;

  if( $PHPSESSID )  {

      if(!isset($_SESSION)){
			session_start($PHPSESSID) ;
		}

      if ( $usr_droits == "admin" || $usr_droits == "user" )  {

         $connected = true ;

      }

  }

  if ( !$connected ) {

      header("location: index.php" ) ;
	  exit();

  }

/************************************/

// Variables

//GET

$p0 = $HTTP_GET_VARS["p0"] ;



/************************************/

$titre  = "Marship : statistiques" ;

$chemin = "Statistiques" ;

include ( DIR_COMMON ."debut.php") ;?>



<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html>

<head>

<title><?php echo $titre;?></title>

<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />

<meta name="description" content="Nous sommes  impliqus, dans la 'logistique portuaire', en apportant nos comptences autour de travaux ou d'oprations (notamment dans le domaine sous-marin) effectues au sein des ports la Martinique, aussi bien que ceux Guadeloupe, o nous sommes reprsents." />

<meta name="KeyWords" content="Marship,Compagnie maritime,Martinique,Maritime,shipping services,fort-de-france"" />

<meta http-equiv="expires" content="604800" />

<meta http-equiv="Content-Script-Type" content="text/javascript"/>

<meta http-equiv="Content-Style-Type" content="text/css"/>

<meta name="robots" content="noindex, nofollow">



<link href="<?php echo DIR_WS;?>marship.css" rel="stylesheet" type="text/css" />

<script language="JavaScript" type="text/javascript" src="<?php echo DIR_WS;?>marship.js"></script>



</head>                   

<body>

<div id="page">



<?php

/******************************************************

*  Lecture de l'enregistrement

*  Affectation des variables

******************************************************/

/*********************************************************

*  Creation du document

**********************************************************/

  // initialisation pied de page

  class PDF extends FPDF {

    function Footer() {

      global $escale;

      //Positionnement  1.5 cm du bas

      $this->SetY(-15);

      // Coordonnes et date

      $this->SetFont('Times','',8);

      $this->SetXY(10,280) ;

      //$this->Cell(190,3,utf8_decode("Marship - Disbursement Account n ").$escale->num."  -  Lo cre ".date("d/m/y"),0,1,'C');

    }

  }



  $pdf = new PDF();



  $pdf->Open();



  $pdf->AddPage();



  // initialisation distance minin de saut de page

  $pdf->SetAutoPageBreak( false,0 ) ;



/*********************************************************

*  Adresse Marship

**********************************************************/

$x = 10;

$y = 5;

$pdf->SetFont('Times','',10);

//$pdf->Rect($x, $y-2, 50, 28 );



$pdf->SetXY($x,$y) ;



/*********************************************************

*  TITRE

**********************************************************/



$lblfont=10;

$colfont=9;

$pdf->SetFont('Times','B',$colfont);

$y = $pdf->GetY() + 15;





switch ($p0) {

    case "affiche":

       include ( DIR_COMMON . "cl_escale.php") ;

        // Controle et transformation date arrive et dpart

        if ( $fdeb != "" && !$deb = isOkDate($fdeb , 0 , 0) ){

             $mes.= "Date d'arrive invalide<br />" ;

        }

        if ( $fdeb == "" ) {

           //$deb = gmmktime(0,0,0,1,1,2000) ;

           $deb = "0000-00-00 00:00:00" ;

        }

        if ( $ffin != "" && !$fin = isOkDate($ffin, 23 , 59) ){

             $mes.= "<br />Date de dpart invalide<br />" ;

        }

        if ( $ffin == "" ) {

           //$fin = gmmktime(23,59,59,12,360,2020) ;

           $fin = "2030-12-31 23:59:59" ;

        }

        if ( $mes !="" ){

             ?>

                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">

                    <tr>

                       <td align="center">

                         <?php echo $mes ;

                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;

                         ?>

                      </td>

                    </tr>

                  </table>

             <?php

             include ( "./footer.php") ;

             exit();

        }

       switch ($champ) {

          case "bat":         ////////// BATEAU

             $query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS bateau

                                FROM ".T_ESCALES."

                                LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id

                                WHERE status ='a'

                                AND  (arrivee <= '$fin' AND depart >= '$deb')

                                ORDER BY bateau,arrivee

                                ";

             //echo "$query<br />";

             $result = mysqli_query( $cnx->id,$query );

             $escale = new escale( $row->id_escale, $cnx->id ) ;

             if ( mysqli_num_rows($result) == 0 ) {

                 ?>

                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">

                    <tr>

                       <td align="center">

                         <?php echo "Aucune escale ne correspond  vos critres de slection" ;

                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;

                         ?>

                      </td>

                    </tr>

                  </table>

                 <?php

                 exit();

             }

             // Affichage en-tete du tableau

			$pdf->SetTextColor(0,51,153);

			$pdf->SetXY($x,$y+2-10) ;

			$pdf->Cell(180,5,"ESCALES PAR BATEAU ENTRE LE ".$fdeb.' et le '.$ffin ,0,0,'C');

		 

		 	$pdf->SetFont('Times','B',$colfont);

			$pdf->SetTextColor(0,51,153);

			$pdf->SetFillColor(153,204,255);

			$pdf->Rect($x, $y, 190,4,'DF');

			

			$pdf->SetXY($x+35,$y) ;

			$pdf->MultiCell(120,5,'Bateau',0,'L');

			

			$pdf->Line($x+90,$y,$x+90,$y+4);

			

			$x = $x + 100;

			$pdf->SetXY($x,$y) ;

			$pdf->MultiCell(120,5,"Arrive",0,'L');

			$pdf->Line($x+30,$y,$x+30,$y+4);

			

			$x = $x + 35;

			$pdf->SetXY($x,$y) ;

			$pdf->MultiCell(120,5,"Dpart",0,'L');

			$pdf->Line($x+25,$y,$x+25,$y+4);

			

			$x = $x + 30;

			$pdf->SetXY($x,$y) ;

			$pdf->MultiCell(120,5,"n d'escale",0,'L');



			$pdf->SetFont('Times','',$colfont);

             // Initialisations compteurs et autres variables

             $i=0;

             $rupt = $bateau;

             $tot = 0;

             $totg = 0;

			 $exit=0;

			 $exit_temp=0;

             While ($row = mysqli_fetch_object($result) ) {

				 $y=$pdf->GetY();

				 $x=$pdf->GetX();

				 

                $escale = new escale( $row->id_escale, $cnx->id ) ;

                $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

				if($bgcolor == "EBEAE7")

				{

					$r=235;$g=234;$b=231;

				}

				else

				{

					//$r=223;$g=224;$b=251;

					$r=255;$g=255;$b=255;

				}	

				

				$pdf->SetFillColor($r,$g,$b);

				$pdf->Rect($x, $y, 190,4,'DF');



                // est-ce le meme bateau ?

                if ( $escale->bateau_nom != $rupt ) {

					

                    // Non. Est-ce la premiere rupture ?

                    if ( $i > 0 ) {

                        // Non : on affiche les totaux du groupe prcedent

                        $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

						$pdf->SetFont('Times','B',$colfont);

						$pdf->SetXY($x,$y) ;

						$pdf->Cell(180,5,'Le bateau '.$str.' est venu '.$tot.' fois' ,0,0,'L');

						$pdf->SetFont('Times','',$colfont);

						$y=$y+5;

						$exit++;

						$exit_temp=1;

                    }

                    // on affiche la premire colonne de la ligne

						$pdf->SetXY($x,$y) ;

						if($exit_temp)

						{

						 $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

							if($bgcolor == "EBEAE7")

							{

								$r=235;$g=234;$b=231;

							}

							else

							{

								$r=223;$g=224;$b=251;

							}	

						$pdf->SetFillColor($r,$g,$b);

						$pdf->Rect($x, $y, 190,4,'DF');	

						$exit_temp=0;

						}

						$pdf->MultiCell(120,5,$escale->bateau_nom,0,'L');

						$pdf->Line($x+90,$y,$x+90,$y+4);



                    // on initialise la variable de rupture

                    $rupt = $escale->bateau_nom;

                    $tot  = 0;

                }

                else {

                   // on affiche la premiere colonne vide car ce n'est pas la premiere ligne pour ce groupe

                }

                // On affiche dans tous les cas le reste de la ligne

				



				$pdf->Line($x+90,$y,$x+90,$y+4);

				$x = $x + 100;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->arrivee),0,'L');

				$pdf->Line($x+30,$y,$x+30,$y+4);

				

				$x = $x + 35;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->depart),0,'L');

				$pdf->Line($x+25,$y,$x+25,$y+4);

				

				$x = $x + 30;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,$escale->num,0,'L');

				

                $tot++;

                $totg++;

                $i++;

				if($y>280)

				{

				$pdf->AddPage();	

				}

								

             }

			 

				



             // on affiche le total du dernier groupe

             $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

			 $y=$y+5;

			 $x=10;

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetFont('Times','B',$colfont);

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'Le bateau '.$str.' est venu '.$tot.' fois' ,0,0,'L');

			 $y=$y+5;

             // on affiche le total gnral

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');

			 

			 

			 	$pdf->SetDisplayMode('fullwidth');

				$filename='Stats_'.$last_id.".pdf";

				$pdf->Output(DIR_FS ."pdf/". $filename,false);

				header("location: pdf/".$filename);

				die();	

			 

          break;

		  // LEO START - Just add the new field in the escale page

		  case "paque":         ////////// Paquebot

             $query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS paquebot, 

			 			".T_ESCALES.".arrivee AS arrivee,  

			 			".T_ESCALES.".membres_dequipage AS equipage, ".T_ESCALES.".passagers_transit AS transit, 

						".T_ESCALES.".passagers_debarques AS debarques, ".T_ESCALES.".passagers_embarques AS embarques

                                FROM ".T_ESCALES."

                                LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id

                                WHERE status ='a'

								AND ".T_BATEAUX.".type = 17

                                AND  (arrivee <= '$fin' AND depart >= '$deb')

                                ORDER BY paquebot,arrivee";

             //echo "$query<br />";

             $result = mysqli_query( $cnx->id,$query);

             if ( mysqli_num_rows($result) == 0 ) {

                 ?>

                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">

                    <tr>

                       <td align="center">

                         <?php echo "Aucune escale ne correspond  vos critres de slection" ;

                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;

                         ?>

                      </td>

                    </tr>

                  </table>

                 <?php

                 exit();

             }

             // Affichage en-tete du tableau

			$pdf->SetTextColor(0,51,153);

			$pdf->SetXY($x,$y+2-10) ;

			$pdf->Cell(180,5,"ESCALES PAR PAQUEBOT ENTRE LE ".$fdeb.' et le '.$ffin ,0,0,'C');

		 

		 	$pdf->SetFont('Times','B',$colfont);

			$pdf->SetTextColor(0,51,153);

			$pdf->SetFillColor(153,204,255);

			$pdf->Rect($x, $y, 190,4,'DF');

			

			$pdf->SetXY($x+2,$y) ;

			$pdf->MultiCell(50,5,'Navire',0,'L');

			

			$pdf->Line($x+50,$y,$x+50,$y+4);

			

			$x = $x + 50;

			$pdf->SetXY($x+10,$y) ;

			$pdf->MultiCell(120,5,"DATE",0,'L');

			$pdf->Line($x+30,$y,$x+30,$y+4);

			

			$x = $x + 35;

			$pdf->SetXY($x+6,$y) ;

			$pdf->MultiCell(130,5,"EQUIPAGE",0,'L');

			$pdf->Line($x+25,$y,$x+25,$y+4);

			

			$x = $x + 30;

			$pdf->SetXY($x,$y) ;

			$pdf->MultiCell(100,5,"EMBARQUANT",0,'L');

			$pdf->Line($x+25,$y,$x+25,$y+4);

			

			$x = $x + 30;

			$pdf->SetXY($x,$y) ;

			$pdf->MultiCell(100,5,"DEBARQUANT",0,'L');

			$pdf->Line($x+25,$y,$x+25,$y+4);

			

			$x = $x + 30;

			$pdf->SetXY($x,$y) ;

			$pdf->MultiCell(100,5,"TRANSIT",0,'L');



			$pdf->SetFont('Times','',$colfont);

             // Initialisations compteurs et autres variables

             $i=0;

             $rupt = $bateau;

             $tot = 0;

             $totg = 0;

			 $exit=0;

			 $exit_temp=0;

             while ($row = mysqli_fetch_object($result) ) {

				 $y=$pdf->GetY();

				 $x=$pdf->GetX();

				 

                $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

				if($bgcolor == "EBEAE7")

				{

					$r=235;$g=234;$b=231;

				}

				else

				{

					//$r=223;$g=224;$b=251;

					$r=255;$g=255;$b=255;

				}	

				

				$pdf->SetFillColor($r,$g,$b);

				$pdf->Rect($x, $y, 190,4,'DF');

				$pdf->SetXY($x+2,$y) ;

				$pdf->MultiCell(50,5,$row->paquebot,0,'L');

				

				$pdf->Line($x+50,$y,$x+50,$y+4);

				

				$x = $x + 50;

				$pdf->SetXY($x+10,$y) ;

				$pdf->MultiCell(120,5,format_date($row->arrivee),0,'L');

				$pdf->Line($x+30,$y,$x+30,$y+4);

				

				$x = $x + 35;

				$pdf->SetXY($x+6,$y) ;

				$pdf->MultiCell(130,5,$row->equipage,0,'L');

				$pdf->Line($x+25,$y,$x+25,$y+4);

				

				$x = $x + 30;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(100,5,$row->embarques,0,'L');

				$pdf->Line($x+25,$y,$x+25,$y+4);

				

				$x = $x + 30;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(100,5,$row->debarques,0,'L');

				$pdf->Line($x+25,$y,$x+25,$y+4);

				

				$x = $x + 30;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(100,5,$row->transit,0,'L');

				

                $tot++;

                $totg++;

                $i++;

				if($y>280)

				{

				$pdf->AddPage();	

				}

								

             }

			 

				



             // on affiche le total du dernier groupe

             $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

			 $y=$y+5;

			 $x=10;

             // on affiche le total gnral

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');

			 

			 

			 	$pdf->SetDisplayMode('fullwidth');

				$filename='Stats_'.$last_id.".pdf";

				$pdf->Output(DIR_FS ."pdf/". $filename,false);

				header("location: pdf/".$filename);

				die();	

			 

          break;

		  // LEO END - Just add the new field in the escale page

          case "arm":         ////////// ARMATEUR

             $query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS bateau,compagnie

                                FROM ".T_ESCALES."

                                LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id

                                LEFT JOIN ".T_TIERS." ON id_arm=".T_TIERS.".id

                                WHERE status ='a'

                                AND  (arrivee <= '$fin' AND depart >= '$deb')

                                ORDER BY ".T_TIERS.".compagnie,bateau,arrivee

                                ";

             // echo "$query<br />";

             $result = mysqli_query( $cnx->id,$query);

             $escale = new escale( $row->id_escale, $cnx->id ) ;

             if ( mysqli_num_rows($result) == 0 ) {

                 ?>

                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">

                    <tr>

                       <td align="center">

                         <?php echo "Aucune escale ne correspond  vos critres de slection" ;

                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;

                         ?>

                      </td>

                    </tr>

                  </table>

                 <?php

                 exit();

             }

             // Affichage en-tete du tableau

            			 

			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetXY($x,$y+2-10) ;

			 $pdf->Cell(180,5,"ESCALES PAR ARMATEUR ENTRE LE  ".$fdeb.' et le '.$ffin ,0,0,'C');

			 

			 

			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');

			

			 $x = $x + 30;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Armateur",0,'L');

			 $pdf->Line($x+50,$y,$x+50,$y+4);

			

			

			 $pdf->SetXY($x+65,$y) ;

			 $pdf->MultiCell(120,5,'Bateau',0,'L');

			

			 $pdf->Line($x+90,$y,$x+90,$y+4);

			

			 $x = $x + 95;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Arrive",0,'L');

			 $pdf->Line($x+15,$y,$x+15,$y+4);

			

			 $x = $x + 22;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Dpart",0,'L');

			 $pdf->Line($x+13,$y,$x+13,$y+4);

			

			 $x = $x + 20;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"n d'escale",0,'L');



			 

             // Initialisations compteurs et autres variables

             $i=0;

             $rupt = $compagnie;

             $tot = 0;

             $totg = 0;

			 $exit_temp=0;

             While ($row = mysqli_fetch_object($result) ) {

				 $y=$pdf->GetY();

				 $x=$pdf->GetX();

                $escale = new escale( $row->id_escale, $cnx->id ) ;

                $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

				

				if($bgcolor == "EBEAE7")

				{

					$r=235;$g=234;$b=231;

				}

				else

				{

					//$r=223;$g=224;$b=251;

					$r=255;$g=255;$b=255;

				}	

				$pdf->SetFont('Times','',$colfont);

				$pdf->SetFillColor($r,$g,$b);

				$pdf->Rect($x, $y, 190,4,'DF');

                // est-ce le meme bateau ?

                if ( $escale->arm_nom != $rupt ) {

                    // Non. Est-ce la premiere rupture ?

                    if ( $i > 0 ) {

                        // Non : on affiche les totaux du groupe prcedent

                        $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

						$pdf->SetFont('Times','B',$colfont);

						$pdf->SetXY($x,$y) ;

						$pdf->Cell(180,5,'L\'armateur '.$str.' est venu '.$tot.' fois' ,0,0,'L');

						$pdf->SetFont('Times','',$colfont);

						$y=$y+5;

						$exit_temp=1;



                    }

                    // on affiche la premire colonne de la ligne

						

						$pdf->SetXY($x,$y) ;

						if($exit_temp)

						{

						 $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

							if($bgcolor == "EBEAE7")

							{

								$r=235;$g=234;$b=231;



							}

							else

							{

								$r=223;$g=224;$b=251;

							}	

						$pdf->SetFillColor($r,$g,$b);

						$pdf->Rect($x, $y, 190,4,'DF');	

						$exit_temp=0;

						}

						

						$pdf->MultiCell(120,5,$escale->arm_nom,0,'L');

						$pdf->Line($x+50,$y,$x+50,$y+4);



						

						

                    // on initialise la variable de rupture

                    $rupt = $escale->arm_nom;

                    $tot  = 0;

                }

                else {

                   // on affiche la premiere colonne vide car ce n'est pas la premiere ligne pour ce groupe

                }

                // On affiche dans tous les cas le reste de la ligne

				

				$pdf->Line($x+80,$y,$x+80,$y+4);



				$pdf->SetXY($x+85,$y) ;

				$pdf->MultiCell(120,5,$escale->bateau_nom,0,'L');

				

				$pdf->Line($x+120,$y,$x+120,$y+4);

				

				$x = $x + 125;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->arrivee),0,'L');

				$pdf->Line($x+15,$y,$x+15,$y+4);

				

				$x = $x + 22;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->depart),0,'L');

				$pdf->Line($x+13,$y,$x+13,$y+4);

				

				$x = $x + 20;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,$escale->num,0,'L');



                $tot++;

                $totg++;

                $i++;

				

				if($y>280)

				{

				$pdf->AddPage();	

				}

             }

             // on affiche le total du dernier groupe

             $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

			 

			 $y=$y+5;

			 $x=10;

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetFont('Times','B',$colfont);

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'L\'armateur '.$str.' est venu '.$tot.' fois' ,0,0,'L');

			 $y=$y+5;

             // on affiche le total gnral

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');

			 

			 

			 	$pdf->SetDisplayMode('fullwidth');

				$filename='Stats_'.$last_id.".pdf";

				$pdf->Output(DIR_FS ."pdf/". $filename,false);

				header("location: pdf/".$filename);

				die();	



          break;



          case "aff":           ////////// AFFRETEUR

             $query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS bateau,compagnie

                                FROM ".T_ESCALES."

                                LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id

                                LEFT JOIN ".T_TIERS." ON id_aff=".T_TIERS.".id

                                WHERE status ='a'

                                AND  (arrivee <= '$fin' AND depart >= '$deb')

                                ORDER BY ".T_TIERS.".compagnie,bateau,arrivee

                                ";

             //echo "$query<br />";

             $result = mysqli_query( $cnx->id,$query);

             if ( mysqli_num_rows($result) == 0 ) {

                 ?>

                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">

                    <tr>

                       <td align="center">

                         <?php echo "Aucune escale ne correspond  vos critres de slection" ;

                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;

                         ?>

                      </td>

                    </tr>

                  </table>

                 <?php

                 exit();

             }

             // Affichage en-tete du tableau

			 

			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetXY($x,$y+2-10) ;

			 $pdf->Cell(180,5,"ESCALES PAR AFFRETEUR ENTRE LE  ".$fdeb.' et le '.$ffin ,0,0,'C');



			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');

			

			 $x = $x + 30;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Affrteur",0,'L');

			 $pdf->Line($x+50,$y,$x+50,$y+4);

			

			

			 $pdf->SetXY($x+65,$y) ;

			 $pdf->MultiCell(120,5,'Bateau',0,'L');

			

			 $pdf->Line($x+90,$y,$x+90,$y+4);

			

			 $x = $x + 95;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Arrive",0,'L');

			 $pdf->Line($x+15,$y,$x+15,$y+4);

			

			 $x = $x + 22;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Dpart",0,'L');

			 $pdf->Line($x+13,$y,$x+13,$y+4);

			

			 $x = $x + 20;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"n d'escale",0,'L');



             // Initialisations compteurs et autres variables

             $i=0;

             $rupt = $compagnie;

             $tot = 0;

             $totg = 0;

			 $exit_temp=0;

             While ($row = mysqli_fetch_object($result) ) {

				 $y=$pdf->GetY();

				 $x=$pdf->GetX();



                $escale = new escale( $row->id_escale, $cnx->id ) ;

                $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

				if($bgcolor == "EBEAE7")

				{

					$r=235;$g=234;$b=231;

				}

				else

				{

					//$r=223;$g=224;$b=251;

					$r=255;$g=255;$b=255;

				}	

				$pdf->SetFont('Times','',$colfont);

				$pdf->SetFillColor($r,$g,$b);

				$pdf->Rect($x, $y, 190,4,'DF');



                // est-ce le meme bateau ?

                if ( $escale->aff_nom != $rupt ) {

                    // Non. Est-ce la premiere rupture ?

                    if ( $i > 0 ) {

                        // Non : on affiche les totaux du groupe prcedent

                        $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

						$pdf->SetFont('Times','B',$colfont);

						$pdf->SetXY($x,$y) ;

						$pdf->Cell(180,5,'L\'affrteur '.$str.' est venu '.$tot.' fois' ,0,0,'L');

						$pdf->SetFont('Times','',$colfont);

						$y=$y+5;

						$exit_temp=1;



                    }

                    // on affiche la premire colonne de la ligne

                    // on initialise la variable de rupture

					

						$pdf->SetXY($x,$y) ;

						if($exit_temp)

						{

						 $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

							if($bgcolor == "EBEAE7")

							{

								$r=235;$g=234;$b=231;

							}

							else

							{

								$r=223;$g=224;$b=251;

							}	

						$pdf->SetFillColor($r,$g,$b);

						$pdf->Rect($x, $y, 190,4,'DF');	

						$exit_temp=0;

						}

						

                   

                    // on affiche la premire colonne de la ligne

						

						

						$pdf->MultiCell(120,5,$escale->aff_nom,0,'L');

						//$pdf->Line($x+50,$y,$x+50,$y+4);

					

                    $rupt = $escale->aff_nom;

                    $tot  = 0;

                }

                else {

                   // on affiche la premiere colonne vide car ce n'est pas la premiere ligne pour ce groupe

                }

                // On affiche dans tous les cas le reste de la ligne

		

				$pdf->Line($x+80,$y,$x+80,$y+4);

				$pdf->SetXY($x+85,$y) ;

				$pdf->MultiCell(120,5,$escale->bateau_nom,0,'L');

				

				$pdf->Line($x+120,$y,$x+120,$y+4);

				

				$x = $x + 125;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->arrivee),0,'L');

				$pdf->Line($x+15,$y,$x+15,$y+4);

				

				$x = $x + 22;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->depart),0,'L');

				$pdf->Line($x+13,$y,$x+13,$y+4);

				

				$x = $x + 20;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,$escale->num,0,'L');



                $tot++;

                $totg++;

                $i++;

				

				if($y>280)

				{

				$pdf->AddPage();	

				}

             }

             // on affiche le total du dernier groupe

             $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

			 

			  $y=$y+5;

			 $x=10;

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetFont('Times','B',$colfont);

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'L\'affrteur '.$str.' est venu '.$tot.' fois' ,0,0,'L');

			 $y=$y+5;

             // on affiche le total gnral

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');

			 

			 

			 	$pdf->SetDisplayMode('fullwidth');

				$filename='Stats_'.$last_id.".pdf";

				$pdf->Output(DIR_FS ."pdf/". $filename,false);

				header("location: pdf/".$filename);

				die();	



			 

          break;



          case "acc":           ////////// ACCOUNTING

             $query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS bateau,compagnie

                                FROM ".T_ESCALES."

                                LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id

                                LEFT JOIN ".T_TIERS." ON id_acc=".T_TIERS.".id

                                WHERE status ='a'

                                AND  (arrivee <= '$fin' AND depart >= '$deb')

                                ORDER BY ".T_TIERS.".compagnie,bateau,arrivee

                                ";

             //echo "$query<br />";

             $result = mysqli_query( $cnx->id,$query);

             if ( mysqli_num_rows($result) == 0 ) {

                 ?>

                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">

                    <tr>

                       <td align="center">

                         <?php echo "Aucune escale ne correspond  vos critres de slection" ;

                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;

                         ?>

                      </td>

                    </tr>

                  </table>

                 <?php

                 exit();

             }

             // Affichage en-tete du tableau

			 

			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetXY($x,$y+2-10) ;

			 $pdf->Cell(180,5,"ESCALES PAR ACCOUNTING ENTRE LE  ".$fdeb.' et le '.$ffin ,0,0,'C');



			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');

			

			 $x = $x + 30;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Accounting",0,'L');

			 $pdf->Line($x+50,$y,$x+50,$y+4);

			

			

			 $pdf->SetXY($x+65,$y) ;

			 $pdf->MultiCell(120,5,'Bateau',0,'L');

			

			 $pdf->Line($x+90,$y,$x+90,$y+4);

			

			 $x = $x + 95;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Arrive",0,'L');

			 $pdf->Line($x+15,$y,$x+15,$y+4);

			

			 $x = $x + 22;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Dpart",0,'L');

			 $pdf->Line($x+13,$y,$x+13,$y+4);

			

			 $x = $x + 20;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"n d'escale",0,'L');



             // Initialisations compteurs et autres variables

             $i=0;

             $rupt = $compagnie;

             $tot = 0;

             $totg = 0;

			 $exit_temp=0;

             While ($row = mysqli_fetch_object($result) ) {

				 $y=$pdf->GetY();

				 $x=$pdf->GetX();

                $escale = new escale( $row->id_escale, $cnx->id ) ;

                $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

				if($bgcolor == "EBEAE7")

				{

					$r=235;$g=234;$b=231;

				}

				else

				{

					//$r=223;$g=224;$b=251;

					$r=255;$g=255;$b=255;

				}	

				$pdf->SetFont('Times','',$colfont);

				$pdf->SetFillColor($r,$g,$b);

				$pdf->Rect($x, $y, 190,4,'DF');

                // est-ce le meme bateau ?



                if ( $escale->acc_nom != $rupt ) {

                    // Non. Est-ce la premiere rupture ?

                    if ( $i > 0 ) {

                        // Non : on affiche les totaux du groupe prcedent

                        $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

						$pdf->SetFont('Times','B',$colfont);

						$pdf->SetXY($x,$y) ;

						$pdf->Cell(180,5,'L\'accounting '.$str.' est venu '.$tot.' fois' ,0,0,'L');

						$pdf->SetFont('Times','',$colfont);

						$y=$y+5;

						$exit_temp=1;

                    }

                    // on affiche la premire colonne de la ligne

                    // on initialise la variable de rupture

					$pdf->SetXY($x,$y) ;

						if($exit_temp)

						{

						 $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

							if($bgcolor == "EBEAE7")

							{

								$r=235;$g=234;$b=231;

							}

							else

							{

								$r=223;$g=224;$b=251;

							}	

						$pdf->SetFillColor($r,$g,$b);

						$pdf->Rect($x, $y, 190,4,'DF');	

						$exit_temp=0;

						}

						

                    // on affiche la premire colonne de la ligne

                    // on initialise la variable de rupture

					

						$pdf->MultiCell(120,5,$escale->acc_nom,0,'L');

						//$pdf->Line($x+50,$y,$x+50,$y+4);

					

                    $rupt = $escale->acc_nom;

                    $tot  = 0;

                }

                else {

                   // on affiche la premiere colonne vide car ce n'est pas la premiere ligne pour ce groupe

                }

                // On affiche dans tous les cas le reste de la ligne

				

				$pdf->Line($x+80,$y,$x+80,$y+4);

				$pdf->SetXY($x+85,$y) ;

				$pdf->MultiCell(120,5,$escale->bateau_nom,0,'L');

				

				$pdf->Line($x+120,$y,$x+120,$y+4);

				

				$x = $x + 125;



				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->arrivee),0,'L');

				$pdf->Line($x+15,$y,$x+15,$y+4);

				

				$x = $x + 22;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->depart),0,'L');

				$pdf->Line($x+13,$y,$x+13,$y+4);

				

				$x = $x + 20;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,$escale->num,0,'L');



                $tot++;

                $totg++;

                $i++;

				

				if($y>280)

				{

				$pdf->AddPage();	

				}



             }

             // on affiche le total du dernier groupe

             $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

			 

			 $y=$y+5;

			 $x=10;

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetFont('Times','B',$colfont);

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'L\'accounting '.$str.' est venu '.$tot.' fois' ,0,0,'L');

			 $y=$y+5;

             // on affiche le total gnral

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');

			 

			 

			 	$pdf->SetDisplayMode('fullwidth');

				$filename='Stats_'.$last_id.".pdf";

				$pdf->Output(DIR_FS ."pdf/". $filename,false);

				header("location: pdf/".$filename);

				die();	



          break;





          case "aut":         //////   INTERVENANT AUTRE

             $query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS bateau,compagnie

                                FROM ".T_ESCALES."

                                LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id

                                LEFT JOIN ".T_TIERS." ON id_aut=".T_TIERS.".id

                                WHERE status ='a'

                                AND  (arrivee <= '$fin' AND depart >= '$deb')

                                ORDER BY ".T_TIERS.".compagnie,bateau,arrivee

                                ";

             //echo "$query<br />";

             $result = mysqli_query( $cnx->id,$query);

             if ( mysqli_num_rows($result) == 0 ) {

                 ?>

                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">

                    <tr>

                       <td align="center">

                         <?php echo "Aucune escale ne correspond  vos critres de slection" ;

                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;

                         ?>

                      </td>

                    </tr>

                  </table>

                 <?php

                 exit();

             }

             // Affichage en-tete du tableau

			 

 			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetXY($x,$y+2-10) ;

			 $pdf->Cell(180,5,"ESCALES PAR INTERVENANT ENTRE LE  ".$fdeb.' et le '.$ffin ,0,0,'C');



			 $pdf->SetTextColor(0,51,153);

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');

			

			 $x = $x + 30;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Intervenant",0,'L');

			 $pdf->Line($x+50,$y,$x+50,$y+4);

			

			

			 $pdf->SetXY($x+65,$y) ;

			 $pdf->MultiCell(120,5,'Bateau',0,'L');

			

			 $pdf->Line($x+90,$y,$x+90,$y+4);

			

			 $x = $x + 95;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Arrive",0,'L');

			 $pdf->Line($x+15,$y,$x+15,$y+4);

			

			 $x = $x + 22;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"Dpart",0,'L');

			 $pdf->Line($x+13,$y,$x+13,$y+4);

			

			 $x = $x + 20;

			 $pdf->SetXY($x,$y) ;

			 $pdf->MultiCell(120,5,"n d'escale",0,'L');



			 

             // Initialisations compteurs et autres variables

             $i=0;

             $rupt = $compagnie;

             $tot = 0;

             $totg = 0;

			 $exit_temp=0;

             While ($row = mysqli_fetch_object($result) ) {

				 $y=$pdf->GetY();

				 $x=$pdf->GetX();

                $escale = new escale( $row->id_escale, $cnx->id ) ;

                $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

				if($bgcolor == "EBEAE7")

				{

					$r=235;$g=234;$b=231;

				}

				else

				{

					//$r=223;$g=224;$b=251;

					$r=255;$g=255;$b=255;

				}	

				$pdf->SetFont('Times','',$colfont);

				$pdf->SetFillColor($r,$g,$b);

				$pdf->Rect($x, $y, 190,4,'DF');

                // est-ce le meme bateau ?

                if ( $escale->aut_nom != $rupt ) {

                    // Non. Est-ce la premiere rupture ?

                    if ( $i > 0 ) {

                        // Non : on affiche les totaux du groupe prcedent

                        $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

						$pdf->SetFont('Times','B',$colfont);

						$pdf->SetXY($x,$y) ;

						$pdf->Cell(180,5,'L\'intervenant '.$str.' est venu '.$tot.' fois' ,0,0,'L');

						$pdf->SetFont('Times','',$colfont);

						$y=$y+5;

						$exit_temp=1;



                    }

                    // on affiche la premire colonne de la ligne

                       $pdf->SetXY($x,$y) ;

						if($exit_temp)

						{

						 $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;

							if($bgcolor == "EBEAE7")

							{

								$r=235;$g=234;$b=231;

							}

							else

							{

								$r=223;$g=224;$b=251;

							}	

						$pdf->SetFillColor($r,$g,$b);

						$pdf->Rect($x, $y, 190,4,'DF');	

						$exit_temp=0;

						}

                    // on initialise la variable de rupture

                    // on affiche la premire colonne de la ligne

                    // on initialise la variable de rupture

					

						

					

						$pdf->MultiCell(120,5,$escale->aut_nom,0,'L');

						//$pdf->Line($x+50,$y,$x+50,$y+4);

					



                    $rupt = $escale->aut_nom;

                    $tot  = 0;

                }

                else {

                   // on affiche la premiere colonne vide car ce n'est pas la premiere ligne pour ce groupe

                }

                // On affiche dans tous les cas le reste de la ligne

				

				$pdf->Line($x+80,$y,$x+80,$y+4);

				$pdf->SetXY($x+85,$y) ;

				$pdf->MultiCell(120,5,$escale->bateau_nom,0,'L');

				

				$pdf->Line($x+120,$y,$x+120,$y+4);

				

				$x = $x + 125;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->arrivee),0,'L');

				$pdf->Line($x+15,$y,$x+15,$y+4);

				

				$x = $x + 22;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,format_date($escale->depart),0,'L');

				$pdf->Line($x+13,$y,$x+13,$y+4);

				

				$x = $x + 20;

				$pdf->SetXY($x,$y) ;

				$pdf->MultiCell(120,5,$escale->num,0,'L');



                $tot++;

                $totg++;

                $i++;

				

				if($y>280)

				{

				$pdf->AddPage();	

				}



             }

             // on affiche le total du dernier groupe

             $rupt == "" ? $str = "* inconnu *" : $str = $rupt;

			 $y=$y+5;

			 $x=10;

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetFont('Times','B',$colfont);

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'L\'intervenant '.$str.' est venu '.$tot.' fois' ,0,0,'L');

			 $y=$y+5;

             // on affiche le total gnral

			 $pdf->SetFillColor(153,204,255);

			 $pdf->Rect($x, $y, 190,4,'DF');	

			 $pdf->SetXY($x,$y) ;

			 $pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');

			 

			 

			 	$pdf->SetDisplayMode('fullwidth');

				$filename='Stats_'.$last_id.".pdf";

				$pdf->Output(DIR_FS ."pdf/". $filename,false);

				header("location: pdf/".$filename);

				die();	



          break;
		  // Start for HP
		  case "quai":         ////////// BATEAU
             $query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS bateau,".T_QUAIS.".nom AS quai
                                FROM ".T_ESCALES."
                                LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id
								LEFT JOIN ".T_QUAIS." ON quai1 = ".T_QUAIS.".id OR quai2 = ".T_QUAIS.".id OR quai3 = ".T_QUAIS.".id
                                WHERE status ='a'
                                AND  (arrivee <= '$fin' AND depart >= '$deb')
                                ORDER BY quai,arrivee
                                ";
             //echo "$query<br />";
             $result = mysqli_query( $cnx->id,$query);
             $escale = new escale( $row->id_escale, $cnx->id ) ;
             if ( mysqli_num_rows($result) == 0 ) {
                 ?>
                  <table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">
                    <tr>
                       <td align="center">
                         <?php echo "Aucune escale ne correspond  vos critres de slection" ;
                            echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;
                         ?>
                      </td>
                    </tr>
                  </table>
                 <?php
                 exit();
             }
             // Affichage en-tete du tableau
			$pdf->SetTextColor(0,51,153);
			$pdf->SetXY($x,$y+2-10) ;
			$pdf->Cell(180,5,"ESCALES PAR QUAI ENTRE LE ".$fdeb.' et le '.$ffin ,0,0,'C');
		 	$pdf->SetFont('Times','B',$colfont);
			$pdf->SetTextColor(0,51,153);
			$pdf->SetFillColor(153,204,255);
			$pdf->Rect($x, $y, 190,4,'DF');
			
			$x = $x + 30;
			$pdf->SetXY($x,$y) ;
			$pdf->MultiCell(120,5,"Quai",0,'L');
			$pdf->Line($x+50,$y,$x+50,$y+4);
			
			$pdf->SetXY($x+65,$y) ;
			$pdf->MultiCell(120,5,'Bateau',0,'L');
			$pdf->Line($x+90,$y,$x+90,$y+4);
			 
			$x = $x + 95;
			$pdf->SetXY($x,$y) ;
			$pdf->MultiCell(120,5,"Arrive",0,'L');
			$pdf->Line($x+15,$y,$x+15,$y+4);

			$x = $x + 22;
			$pdf->SetXY($x,$y) ;
			$pdf->MultiCell(120,5,"Dpart",0,'L');
			$pdf->Line($x+13,$y,$x+13,$y+4);
			
			$x = $x + 20;
			$pdf->SetXY($x,$y) ;
			$pdf->MultiCell(120,5,"n d'escale",0,'L');
             // Initialisations compteurs et autres variables
            $i=0;
            $rupt = $quai;
            $tot = 0;
            $totg = 0;
			$exit=0;
  		    $exit_temp=0;
            While ($row = mysqli_fetch_object($result) ) {
				$y=$pdf->GetY();
				$x=$pdf->GetX();
                $escale = new escale( $row->id_escale, $cnx->id ) ;
                $bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
				if($bgcolor == "EBEAE7"){
					$r=235;$g=234;$b=231;
				}else{
					$r=223;$g=234;$b=251;
					//$r=255;$g=255;$b=255;
				}
				$pdf->SetFont('Times','',$colfont);	
				$pdf->SetFillColor($r,$g,$b);
				$pdf->Rect($x, $y, 190,4,'DF');
                // est-ce le meme bateau ?
                if ( $row->quai != $rupt ) {
                    // Non. Est-ce la premiere rupture ?
                    if ( $i > 0 ) {
                        // Non : on affiche les totaux du groupe prcedent
                        $rupt == "" ? $str = "* inconnu *" : $str = $rupt;
						$pdf->SetFont('Times','B',$colfont);
						$pdf->SetFillColor(153,204,255);
						$pdf->Rect($x, $y, 190,4,'DF');
						$pdf->SetXY($x,$y) ;
						$pdf->Cell(180,5,'Quai '.$str.' accost '.$tot.' fois' ,0,0,'L');
						$pdf->SetFont('Times','',$colfont);
						$y=$y+5;
						$exit++;
						$exit_temp=1;
                    }
                    // on affiche la premire colonne de la ligne
					$pdf->SetXY($x,$y) ;
					if($exit_temp){
						$bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
						if($bgcolor == "EBEAE7"){
							$r=235;$g=234;$b=231;
						}else{
							$r=223;$g=234;$b=251;
							//$r=255;$g=255;$b=255;
						}	
						$pdf->SetFillColor($r,$g,$b);
						$pdf->Rect($x, $y, 190,4,'DF');	
						$exit_temp=0;
					}
					$pdf->MultiCell(120,5,$row->quai,0,'L');
					$pdf->Line($x+80,$y,$x+80,$y+4);
                    // on initialise la variable de rupture
                    $rupt = $row->quai;
                    $tot  = 0;
                }else {
                   // on affiche la premiere colonne vide car ce n'est pas la premiere ligne pour ce groupe
				   $pdf->MultiCell(120,5,'',0,'L');
				   $pdf->Line($x+80,$y,$x+80,$y+4);
                }
                // On affiche dans tous les cas le reste de la ligne

				//$pdf->Line($x+90,$y,$x+90,$y+4);

				$pdf->SetXY($x+85,$y) ;
				$pdf->MultiCell(120,5,$escale->bateau_nom,0,'L');
				$pdf->Line($x+120,$y,$x+120,$y+4);
				
				$x = $x + 125;
				$pdf->SetXY($x,$y) ;
				$pdf->MultiCell(120,5,format_date($escale->arrivee),0,'L');
				$pdf->Line($x+15,$y,$x+15,$y+4);
				
				$x = $x + 22;
				$pdf->SetXY($x,$y) ;
				$pdf->MultiCell(120,5,format_date($escale->depart),0,'L');
				$pdf->Line($x+13,$y,$x+13,$y+4);
				
				$x = $x + 20;
				$pdf->SetXY($x,$y) ;
				$pdf->MultiCell(120,5,$escale->num,0,'L');
				
                $tot++;
                $totg++;
                $i++;
				if($y>280){
					$pdf->AddPage();	
				}
             }
             // on affiche le total du dernier groupe
             $rupt == "" ? $str = "* inconnu *" : $str = $rupt;
			 $y=$y+5;
			 $x=10;
			 $pdf->SetFillColor(153,204,255);
			 $pdf->Rect($x, $y, 190,4,'DF');	
			 $pdf->SetFont('Times','B',$colfont);
			 $pdf->SetXY($x,$y) ;
			 $pdf->Cell(180,5,'Quai '.$str.' accost '.$tot.' fois' ,0,0,'L');
			 $y=$y+5;
             // on affiche le total gnral
			 $pdf->SetFillColor(153,204,255);
			 $pdf->Rect($x, $y, 190,4,'DF');	
			 $pdf->SetXY($x,$y) ;
			 $pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');

			 $pdf->SetDisplayMode('fullwidth');
			 $filename='Stats_'.$last_id.".pdf";
			 $pdf->Output(DIR_FS ."pdf/". $filename,false);
			 header("location: pdf/".$filename);
			 die();	
          break;
		  // End for HP
		  
		  //Start for HP(crew change)
		  case "crew_change":         ////////// Crew Change
				$query = "SELECT ".T_ESCALES.".id AS id_escale,".T_BATEAUX.".nom AS bateau
					FROM ".T_ESCALES."
					LEFT JOIN ".T_BATEAUX." ON id_bateau=".T_BATEAUX.".id
					WHERE status ='a'
					AND crew_change=1 
					AND  (arrivee <= '$fin' AND depart >= '$deb')
					ORDER BY bateau,arrivee
				";
				$result = mysqli_query( $cnx->id,$query);
				$escale = new escale( $row->id_escale, $cnx->id ) ;
				if ( mysqli_num_rows($result) == 0 ) {
		?>
					<table border="0" align="center" cellpadding="0" width="95%" height="200" cellspacing="6">
						<tr>
							<td align="center">
								<?php 
									echo "Aucune escale ne correspond  vos critres de slection" ;
									echo "<br /><br /><a href=\"javascript:history.back()\">Retour</a>" ;
								?>
							</td>
						</tr>
					</table>
		<?php
					exit();
				}
				// Affichage en-tete du tableau
				$pdf->SetTextColor(0,51,153);
				$pdf->SetXY($x,$y+2-10) ;
				$pdf->Cell(180,5,"ESCALES PAR CREW CHANGE ENTRE LE ".$fdeb.' et le '.$ffin ,0,0,'C');

				$pdf->SetFont('Times','B',$colfont);
				$pdf->SetTextColor(0,51,153);
				$pdf->SetFillColor(153,204,255);
				$pdf->Rect($x, $y, 190,4,'DF');

				$pdf->SetXY($x+35,$y) ;
				$pdf->MultiCell(120,5,'Bateau',0,'L');
				$pdf->Line($x+90,$y,$x+90,$y+4);

				$x = $x + 100;
				$pdf->SetXY($x,$y) ;
				$pdf->MultiCell(120,5,"Arrive",0,'L');
				$pdf->Line($x+30,$y,$x+30,$y+4);

				$x = $x + 35;
				$pdf->SetXY($x,$y) ;
				$pdf->MultiCell(120,5,"Dpart",0,'L');
				$pdf->Line($x+25,$y,$x+25,$y+4);

				$x = $x + 30;
				$pdf->SetXY($x,$y) ;
				$pdf->MultiCell(120,5,"n d'escale",0,'L');
				$pdf->SetFont('Times','',$colfont);
				// Initialisations compteurs et autres variables

				$i=0;
				$rupt = $bateau;
				$tot = 0;
				$totg = 0;
				$exit=0;
				$exit_temp=0;

				While ($row = mysqli_fetch_object($result) ) {
					$y=$pdf->GetY();
					$x=$pdf->GetX();
					$escale = new escale( $row->id_escale, $cnx->id ) ;
					$bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
					if($bgcolor == "EBEAE7"){
						$r=235;$g=234;$b=231;
					}else{
						$r=255;$g=255;$b=255;
					}	

					$pdf->SetFillColor($r,$g,$b);
					$pdf->Rect($x, $y, 190,4,'DF');

					// est-ce le meme bateau ?
					if ( $escale->bateau_nom != $rupt ) {
					// Non. Est-ce la premiere rupture ?
						if ( $i > 0 ) {
						// Non : on affiche les totaux du groupe prcedent
							$rupt == "" ? $str = "* inconnu *" : $str = $rupt;
							$pdf->SetFont('Times','B',$colfont);
							$pdf->SetXY($x,$y) ;
							$pdf->Cell(180,5,'Le crew change '.$str.' est venu '.$tot.' fois' ,0,0,'L');
							$pdf->SetFont('Times','',$colfont);

							$y=$y+5;
							$exit++;
							$exit_temp=1;
						}

						// on affiche la premire colonne de la ligne
						$pdf->SetXY($x,$y) ;
						if($exit_temp){
							$bgcolor == "EBEAE7" ? $bgcolor = "DFEAFB" : $bgcolor = "EBEAE7" ;
							if($bgcolor == "EBEAE7"){
								$r=235;$g=234;$b=231;
							}else{
								$r=223;$g=224;$b=251;
							}	
							$pdf->SetFillColor($r,$g,$b);
							$pdf->Rect($x, $y, 190,4,'DF');	
							$exit_temp=0;
						}

						$pdf->MultiCell(120,5,$escale->bateau_nom,0,'L');
						$pdf->Line($x+90,$y,$x+90,$y+4);
						// on initialise la variable de rupture
						$rupt = $escale->bateau_nom;
						$tot  = 0;
					}else{
						// on affiche la premiere colonne vide car ce n'est pas la premiere ligne pour ce groupe
					}
					// On affiche dans tous les cas le reste de la ligne
					$pdf->Line($x+90,$y,$x+90,$y+4);
					$x = $x + 100;
					$pdf->SetXY($x,$y) ;
					$pdf->MultiCell(120,5,format_date($escale->arrivee),0,'L');
					$pdf->Line($x+30,$y,$x+30,$y+4);

					$x = $x + 35;
					$pdf->SetXY($x,$y) ;
					$pdf->MultiCell(120,5,format_date($escale->depart),0,'L');
					$pdf->Line($x+25,$y,$x+25,$y+4);
					
					$x = $x + 30;
					$pdf->SetXY($x,$y) ;
					$pdf->MultiCell(120,5,$escale->num,0,'L');
					
					$tot++;
					$totg++;
					$i++;
					if($y>280){
						$pdf->AddPage();	
					}
				}
				// on affiche le total du dernier groupe
				$rupt == "" ? $str = "* inconnu *" : $str = $rupt;
				$y=$y+5;
				$x=10;
				$pdf->SetFillColor(153,204,255);
				$pdf->Rect($x, $y, 190,4,'DF');	
				$pdf->SetFont('Times','B',$colfont);
				$pdf->SetXY($x,$y) ;
				$pdf->Cell(180,5,'Le crew change '.$str.' est venu '.$tot.' fois' ,0,0,'L');
				
				$y=$y+5;
				// on affiche le total gnral
				$pdf->SetFillColor(153,204,255);
				$pdf->Rect($x, $y, 190,4,'DF');	
				$pdf->SetXY($x,$y) ;
				$pdf->Cell(180,5,'Nombre total d\'escales entre le '.$fdeb.' et le '.$ffin.' : '.$totg ,0,0,'L');
				$pdf->SetDisplayMode('fullwidth');
				$filename='Stats_'.$last_id.".pdf";
				
				$pdf->Output(DIR_FS ."pdf/". $filename,false);
				header("location: pdf/".$filename);
				die();	
			break;
		  //End for HP(crew change)

       }   // Fin switch $champ



    break; // Fin affiche



    default:  // 1er passage : demande des critres de selection

      // initialisation des dates par dfaut

      $fdeb = "01/01/".date("y");

      $ffin = date("d/m/y");

?>

</div>

<?php

}  // Fin switch $p0

// Pied de page







include ("footer.php") ;

?>

</body>
